
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | XOR
    | WITH
    | VOID
    | UNIT
    | TYPE
    | TRUE
    | TIMES
    | THEORY
    | THEN
    | STRING of (
# 42 "src/parsers/native_parser.mly"
       (string)
# 24 "src/parsers/native_parser.ml"
  )
    | SLASH
    | SHARP
    | RIGHTSQ
    | RIGHTPAR
    | RIGHTBR
    | RIGHTARROW
    | REWRITING
    | REAL
    | QUOTE
    | QM_ID of (
# 39 "src/parsers/native_parser.mly"
       (string)
# 38 "src/parsers/native_parser.ml"
  )
    | QM
    | PV
    | PROP
    | PRED
    | POWDOT
    | POW
    | PLUS
    | PERCENT
    | OR
    | OF
    | NUM of (
# 41 "src/parsers/native_parser.mly"
       (Num.num)
# 53 "src/parsers/native_parser.ml"
  )
    | NOTEQ
    | NOT
    | MINUS
    | MATCH
    | MAPS_TO
    | LT
    | LRARROW
    | LOGIC
    | LET
    | LEFTSQ
    | LEFTPAR
    | LEFTBR
    | LEFTARROW
    | LE
    | INTEGER of (
# 40 "src/parsers/native_parser.mly"
       (string)
# 72 "src/parsers/native_parser.ml"
  )
    | INT
    | IN
    | IF
    | ID of (
# 38 "src/parsers/native_parser.mly"
       (string)
# 80 "src/parsers/native_parser.ml"
  )
    | HAT
    | GT
    | GOAL
    | GE
    | FUNC
    | FORALL
    | FALSE
    | EXTENDS
    | EXISTS
    | EQUAL
    | EOF
    | END
    | ELSE
    | DOT
    | DISTINCT
    | CUT
    | COMMA
    | COLON
    | CHECK
    | CASESPLIT
    | BOOL
    | BITV
    | BAR
    | AXIOM
    | AT
    | AND
    | AC
  
end

include MenhirBasics

# 29 "src/parsers/native_parser.mly"
  
  [@@@ocaml.warning "-33"]
  open AltErgoLib
  open Options
  open Parsed_interface

# 121 "src/parsers/native_parser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_file_parser) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: file_parser. *)

  | MenhirState001 : (('s, _menhir_box_file_parser) _menhir_cell1_TYPE, _menhir_box_file_parser) _menhir_state
    (** State 001.
        Stack shape : TYPE.
        Start symbol: file_parser. *)

  | MenhirState002 : (('s, 'r) _menhir_cell1_QUOTE, 'r) _menhir_state
    (** State 002.
        Stack shape : QUOTE.
        Start symbol: <undetermined>. *)

  | MenhirState005 : (('s, _menhir_box_file_parser) _menhir_cell1_LEFTPAR, _menhir_box_file_parser) _menhir_state
    (** State 005.
        Stack shape : LEFTPAR.
        Start symbol: file_parser. *)

  | MenhirState007 : (('s, _menhir_box_file_parser) _menhir_cell1_type_var, _menhir_box_file_parser) _menhir_state
    (** State 007.
        Stack shape : type_var.
        Start symbol: file_parser. *)

  | MenhirState011 : ((('s, _menhir_box_file_parser) _menhir_cell1_TYPE, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_state
    (** State 011.
        Stack shape : TYPE type_vars.
        Start symbol: file_parser. *)

  | MenhirState013 : (((('s, _menhir_box_file_parser) _menhir_cell1_TYPE, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 013.
        Stack shape : TYPE type_vars ident.
        Start symbol: file_parser. *)

  | MenhirState014 : (('s, _menhir_box_file_parser) _menhir_cell1_LEFTBR, _menhir_box_file_parser) _menhir_state
    (** State 014.
        Stack shape : LEFTBR.
        Start symbol: file_parser. *)

  | MenhirState018 : (('s, _menhir_box_file_parser) _menhir_cell1_label_with_type _menhir_cell0_PV, _menhir_box_file_parser) _menhir_state
    (** State 018.
        Stack shape : label_with_type PV.
        Start symbol: file_parser. *)

  | MenhirState021 : (('s, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 021.
        Stack shape : ident.
        Start symbol: file_parser. *)

  | MenhirState024 : (('s, 'r) _menhir_cell1_LEFTPAR, 'r) _menhir_state
    (** State 024.
        Stack shape : LEFTPAR.
        Start symbol: <undetermined>. *)

  | MenhirState032 : (('s, 'r) _menhir_cell1_primitive_type, 'r) _menhir_state
    (** State 032.
        Stack shape : primitive_type.
        Start symbol: <undetermined>. *)

  | MenhirState033 : ((('s, 'r) _menhir_cell1_primitive_type, 'r) _menhir_cell1_COMMA, 'r) _menhir_state
    (** State 033.
        Stack shape : primitive_type COMMA.
        Start symbol: <undetermined>. *)

  | MenhirState038 : ((('s, 'r) _menhir_cell1_LEFTPAR, 'r) _menhir_cell1_list1_primitive_type_sep_comma _menhir_cell0_RIGHTPAR, 'r) _menhir_state
    (** State 038.
        Stack shape : LEFTPAR list1_primitive_type_sep_comma RIGHTPAR.
        Start symbol: <undetermined>. *)

  | MenhirState040 : ((('s, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_primitive_type, _menhir_box_file_parser) _menhir_state
    (** State 040.
        Stack shape : ident primitive_type.
        Start symbol: file_parser. *)

  | MenhirState042 : ((((('s, _menhir_box_file_parser) _menhir_cell1_TYPE, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar, _menhir_box_file_parser) _menhir_state
    (** State 042.
        Stack shape : TYPE type_vars ident list1_constructors_sep_bar.
        Start symbol: file_parser. *)

  | MenhirState043 : ((((('s, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar, _menhir_box_file_parser) _menhir_cell1_AND, _menhir_box_file_parser) _menhir_state
    (** State 043.
        Stack shape : type_vars ident list1_constructors_sep_bar AND.
        Start symbol: file_parser. *)

  | MenhirState044 : (((((('s, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar, _menhir_box_file_parser) _menhir_cell1_AND, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_state
    (** State 044.
        Stack shape : type_vars ident list1_constructors_sep_bar AND type_vars.
        Start symbol: file_parser. *)

  | MenhirState046 : ((((((('s, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar, _menhir_box_file_parser) _menhir_cell1_AND, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 046.
        Stack shape : type_vars ident list1_constructors_sep_bar AND type_vars ident.
        Start symbol: file_parser. *)

  | MenhirState047 : (((((((('s, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar, _menhir_box_file_parser) _menhir_cell1_AND, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar, _menhir_box_file_parser) _menhir_state
    (** State 047.
        Stack shape : type_vars ident list1_constructors_sep_bar AND type_vars ident list1_constructors_sep_bar.
        Start symbol: file_parser. *)

  | MenhirState050 : (('s, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 050.
        Stack shape : ident.
        Start symbol: file_parser. *)

  | MenhirState053 : (('s, _menhir_box_file_parser) _menhir_cell1_ident _menhir_cell0_algebraic_args, _menhir_box_file_parser) _menhir_state
    (** State 053.
        Stack shape : ident algebraic_args.
        Start symbol: file_parser. *)

  | MenhirState057 : (('s, _menhir_box_file_parser) _menhir_cell1_THEORY, _menhir_box_file_parser) _menhir_state
    (** State 057.
        Stack shape : THEORY.
        Start symbol: file_parser. *)

  | MenhirState059 : ((('s, _menhir_box_file_parser) _menhir_cell1_THEORY, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 059.
        Stack shape : THEORY ident.
        Start symbol: file_parser. *)

  | MenhirState061 : (((('s, _menhir_box_file_parser) _menhir_cell1_THEORY, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 061.
        Stack shape : THEORY ident ident.
        Start symbol: file_parser. *)

  | MenhirState062 : (('s, _menhir_box_file_parser) _menhir_cell1_CASESPLIT, _menhir_box_file_parser) _menhir_state
    (** State 062.
        Stack shape : CASESPLIT.
        Start symbol: file_parser. *)

  | MenhirState064 : ((('s, _menhir_box_file_parser) _menhir_cell1_CASESPLIT, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 064.
        Stack shape : CASESPLIT ident.
        Start symbol: file_parser. *)

  | MenhirState068 : (('s, 'r) _menhir_cell1_STRING, 'r) _menhir_state
    (** State 068.
        Stack shape : STRING.
        Start symbol: <undetermined>. *)

  | MenhirState070 : (('s, 'r) _menhir_cell1_NOT, 'r) _menhir_state
    (** State 070.
        Stack shape : NOT.
        Start symbol: <undetermined>. *)

  | MenhirState071 : (('s, 'r) _menhir_cell1_MINUS, 'r) _menhir_state
    (** State 071.
        Stack shape : MINUS.
        Start symbol: <undetermined>. *)

  | MenhirState072 : (('s, 'r) _menhir_cell1_MATCH, 'r) _menhir_state
    (** State 072.
        Stack shape : MATCH.
        Start symbol: <undetermined>. *)

  | MenhirState073 : (('s, 'r) _menhir_cell1_LET, 'r) _menhir_state
    (** State 073.
        Stack shape : LET.
        Start symbol: <undetermined>. *)

  | MenhirState075 : ((('s, 'r) _menhir_cell1_LET, 'r) _menhir_cell1_let_binders, 'r) _menhir_state
    (** State 075.
        Stack shape : LET let_binders.
        Start symbol: <undetermined>. *)

  | MenhirState081 : (('s, 'r) _menhir_cell1_LEFTPAR, 'r) _menhir_state
    (** State 081.
        Stack shape : LEFTPAR.
        Start symbol: <undetermined>. *)

  | MenhirState082 : (('s, 'r) _menhir_cell1_LEFTBR, 'r) _menhir_state
    (** State 082.
        Stack shape : LEFTBR.
        Start symbol: <undetermined>. *)

  | MenhirState086 : ((('s, 'r) _menhir_cell1_LEFTBR, 'r) _menhir_cell1_simple_expr, 'r) _menhir_state
    (** State 086.
        Stack shape : LEFTBR simple_expr.
        Start symbol: <undetermined>. *)

  | MenhirState090 : (('s, 'r) _menhir_cell1_ident, 'r) _menhir_state
    (** State 090.
        Stack shape : ident.
        Start symbol: <undetermined>. *)

  | MenhirState091 : (('s, 'r) _menhir_cell1_IF, 'r) _menhir_state
    (** State 091.
        Stack shape : IF.
        Start symbol: <undetermined>. *)

  | MenhirState092 : (('s, 'r) _menhir_cell1_FORALL, 'r) _menhir_state
    (** State 092.
        Stack shape : FORALL.
        Start symbol: <undetermined>. *)

  | MenhirState096 : (('s, 'r) _menhir_cell1_named_ident, 'r) _menhir_state
    (** State 096.
        Stack shape : named_ident.
        Start symbol: <undetermined>. *)

  | MenhirState099 : (('s, 'r) _menhir_cell1_multi_logic_binder, 'r) _menhir_state
    (** State 099.
        Stack shape : multi_logic_binder.
        Start symbol: <undetermined>. *)

  | MenhirState101 : (('s, 'r) _menhir_cell1_list1_named_ident_sep_comma, 'r) _menhir_state
    (** State 101.
        Stack shape : list1_named_ident_sep_comma.
        Start symbol: <undetermined>. *)

  | MenhirState102 : ((('s, 'r) _menhir_cell1_list1_named_ident_sep_comma, 'r) _menhir_cell1_primitive_type, 'r) _menhir_state
    (** State 102.
        Stack shape : list1_named_ident_sep_comma primitive_type.
        Start symbol: <undetermined>. *)

  | MenhirState104 : ((('s, 'r) _menhir_cell1_FORALL, 'r) _menhir_cell1_list1_multi_logic_binder, 'r) _menhir_state
    (** State 104.
        Stack shape : FORALL list1_multi_logic_binder.
        Start symbol: <undetermined>. *)

  | MenhirState105 : ((('s, 'r) _menhir_cell1_list1_multi_logic_binder, 'r) _menhir_cell1_LEFTSQ, 'r) _menhir_state
    (** State 105.
        Stack shape : list1_multi_logic_binder LEFTSQ.
        Start symbol: <undetermined>. *)

  | MenhirState106 : (('s, 'r) _menhir_cell1_EXISTS, 'r) _menhir_state
    (** State 106.
        Stack shape : EXISTS.
        Start symbol: <undetermined>. *)

  | MenhirState107 : ((('s, 'r) _menhir_cell1_EXISTS, 'r) _menhir_cell1_list1_multi_logic_binder, 'r) _menhir_state
    (** State 107.
        Stack shape : EXISTS list1_multi_logic_binder.
        Start symbol: <undetermined>. *)

  | MenhirState108 : (((('s, 'r) _menhir_cell1_EXISTS, 'r) _menhir_cell1_list1_multi_logic_binder, 'r) _menhir_cell1_triggers, 'r) _menhir_state
    (** State 108.
        Stack shape : EXISTS list1_multi_logic_binder triggers.
        Start symbol: <undetermined>. *)

  | MenhirState109 : (((('s, 'r) _menhir_cell1_list1_multi_logic_binder, 'r) _menhir_cell1_triggers, 'r) _menhir_cell1_LEFTBR, 'r) _menhir_state
    (** State 109.
        Stack shape : list1_multi_logic_binder triggers LEFTBR.
        Start symbol: <undetermined>. *)

  | MenhirState111 : (('s, 'r) _menhir_cell1_DISTINCT _menhir_cell0_LEFTPAR, 'r) _menhir_state
    (** State 111.
        Stack shape : DISTINCT LEFTPAR.
        Start symbol: <undetermined>. *)

  | MenhirState112 : (('s, 'r) _menhir_cell1_CUT, 'r) _menhir_state
    (** State 112.
        Stack shape : CUT.
        Start symbol: <undetermined>. *)

  | MenhirState113 : (('s, 'r) _menhir_cell1_CHECK, 'r) _menhir_state
    (** State 113.
        Stack shape : CHECK.
        Start symbol: <undetermined>. *)

  | MenhirState115 : (('s, 'r) _menhir_cell1_simple_expr, 'r) _menhir_state
    (** State 115.
        Stack shape : simple_expr.
        Start symbol: <undetermined>. *)

  | MenhirState118 : (('s, 'r) _menhir_cell1_simple_expr _menhir_cell0_QM, 'r) _menhir_state
    (** State 118.
        Stack shape : simple_expr QM.
        Start symbol: <undetermined>. *)

  | MenhirState120 : (('s, 'r) _menhir_cell1_simple_expr _menhir_cell0_LEFTSQ, 'r) _menhir_state
    (** State 120.
        Stack shape : simple_expr LEFTSQ.
        Start symbol: <undetermined>. *)

  | MenhirState122 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 122.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState124 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 124.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState133 : (('s, 'r) _menhir_cell1_ident _menhir_cell0_LEFTPAR, 'r) _menhir_state
    (** State 133.
        Stack shape : ident LEFTPAR.
        Start symbol: <undetermined>. *)

  | MenhirState138 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 138.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState140 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 140.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState142 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 142.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState144 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 144.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState146 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 146.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState148 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 148.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState150 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 150.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState152 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 152.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState154 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 154.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState156 : (('s, 'r) _menhir_cell1_lexpr _menhir_cell0_MINUS, 'r) _menhir_state
    (** State 156.
        Stack shape : lexpr MINUS.
        Start symbol: <undetermined>. *)

  | MenhirState158 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 158.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState160 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 160.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState162 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 162.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState164 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 164.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState166 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 166.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState168 : (('s, 'r) _menhir_cell1_lexpr _menhir_cell0_AND, 'r) _menhir_state
    (** State 168.
        Stack shape : lexpr AND.
        Start symbol: <undetermined>. *)

  | MenhirState170 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 170.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState172 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 172.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState175 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 175.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState180 : (('s, 'r) _menhir_cell1_array_assignement, 'r) _menhir_state
    (** State 180.
        Stack shape : array_assignement.
        Start symbol: <undetermined>. *)

  | MenhirState183 : (('s, 'r) _menhir_cell1_simple_expr, 'r) _menhir_state
    (** State 183.
        Stack shape : simple_expr.
        Start symbol: <undetermined>. *)

  | MenhirState185 : (('s, 'r) _menhir_cell1_simple_expr, 'r) _menhir_state
    (** State 185.
        Stack shape : simple_expr.
        Start symbol: <undetermined>. *)

  | MenhirState186 : ((('s, 'r) _menhir_cell1_simple_expr, 'r) _menhir_cell1_primitive_type, 'r) _menhir_state
    (** State 186.
        Stack shape : simple_expr primitive_type.
        Start symbol: <undetermined>. *)

  | MenhirState192 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 192.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState197 : ((((('s, 'r) _menhir_cell1_list1_multi_logic_binder, 'r) _menhir_cell1_triggers, 'r) _menhir_cell1_LEFTBR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 197.
        Stack shape : list1_multi_logic_binder triggers LEFTBR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState201 : ((((('s, 'r) _menhir_cell1_EXISTS, 'r) _menhir_cell1_list1_multi_logic_binder, 'r) _menhir_cell1_triggers, 'r) _menhir_cell1_filters, 'r) _menhir_state
    (** State 201.
        Stack shape : EXISTS list1_multi_logic_binder triggers filters.
        Start symbol: <undetermined>. *)

  | MenhirState204 : (('s, 'r) _menhir_cell1_trigger, 'r) _menhir_state
    (** State 204.
        Stack shape : trigger.
        Start symbol: <undetermined>. *)

  | MenhirState208 : (('s, 'r) _menhir_cell1_lexpr_or_dom, 'r) _menhir_state
    (** State 208.
        Stack shape : lexpr_or_dom.
        Start symbol: <undetermined>. *)

  | MenhirState211 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 211.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState214 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_sq, 'r) _menhir_state
    (** State 214.
        Stack shape : lexpr sq.
        Start symbol: <undetermined>. *)

  | MenhirState224 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_sq, 'r) _menhir_cell1_bound, 'r) _menhir_state
    (** State 224.
        Stack shape : lexpr sq bound.
        Start symbol: <undetermined>. *)

  | MenhirState225 : ((((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_sq, 'r) _menhir_cell1_bound, 'r) _menhir_cell1_bound, 'r) _menhir_state
    (** State 225.
        Stack shape : lexpr sq bound bound.
        Start symbol: <undetermined>. *)

  | MenhirState228 : (('s, 'r) _menhir_cell1_ident, 'r) _menhir_state
    (** State 228.
        Stack shape : ident.
        Start symbol: <undetermined>. *)

  | MenhirState232 : (((('s, 'r) _menhir_cell1_FORALL, 'r) _menhir_cell1_list1_multi_logic_binder, 'r) _menhir_cell1_triggers, 'r) _menhir_state
    (** State 232.
        Stack shape : FORALL list1_multi_logic_binder triggers.
        Start symbol: <undetermined>. *)

  | MenhirState234 : ((((('s, 'r) _menhir_cell1_FORALL, 'r) _menhir_cell1_list1_multi_logic_binder, 'r) _menhir_cell1_triggers, 'r) _menhir_cell1_filters, 'r) _menhir_state
    (** State 234.
        Stack shape : FORALL list1_multi_logic_binder triggers filters.
        Start symbol: <undetermined>. *)

  | MenhirState237 : ((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 237.
        Stack shape : IF lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState239 : (((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 239.
        Stack shape : IF lexpr lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState242 : ((('s, 'r) _menhir_cell1_ident, 'r) _menhir_cell1_lexpr _menhir_cell0_PV, 'r) _menhir_state
    (** State 242.
        Stack shape : ident lexpr PV.
        Start symbol: <undetermined>. *)

  | MenhirState251 : (('s, 'r) _menhir_cell1_ident, 'r) _menhir_state
    (** State 251.
        Stack shape : ident.
        Start symbol: <undetermined>. *)

  | MenhirState253 : ((('s, 'r) _menhir_cell1_ident, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 253.
        Stack shape : ident lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState256 : ((('s, 'r) _menhir_cell1_MATCH, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 256.
        Stack shape : MATCH lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState257 : (((('s, 'r) _menhir_cell1_MATCH, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_BAR, 'r) _menhir_state
    (** State 257.
        Stack shape : MATCH lexpr BAR.
        Start symbol: <undetermined>. *)

  | MenhirState259 : ((((('s, 'r) _menhir_cell1_MATCH, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_BAR, 'r) _menhir_cell1_simple_pattern, 'r) _menhir_state
    (** State 259.
        Stack shape : MATCH lexpr BAR simple_pattern.
        Start symbol: <undetermined>. *)

  | MenhirState262 : (('s, 'r) _menhir_cell1_ident _menhir_cell0_LEFTPAR, 'r) _menhir_state
    (** State 262.
        Stack shape : ident LEFTPAR.
        Start symbol: <undetermined>. *)

  | MenhirState266 : (('s, 'r) _menhir_cell1_ident, 'r) _menhir_state
    (** State 266.
        Stack shape : ident.
        Start symbol: <undetermined>. *)

  | MenhirState269 : (((('s, 'r) _menhir_cell1_MATCH, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_simple_pattern, 'r) _menhir_state
    (** State 269.
        Stack shape : MATCH lexpr simple_pattern.
        Start symbol: <undetermined>. *)

  | MenhirState273 : (((('s, 'r) _menhir_cell1_MATCH, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_list1_match_cases, 'r) _menhir_state
    (** State 273.
        Stack shape : MATCH lexpr list1_match_cases.
        Start symbol: <undetermined>. *)

  | MenhirState275 : ((((('s, 'r) _menhir_cell1_MATCH, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_list1_match_cases, 'r) _menhir_cell1_simple_pattern, 'r) _menhir_state
    (** State 275.
        Stack shape : MATCH lexpr list1_match_cases simple_pattern.
        Start symbol: <undetermined>. *)

  | MenhirState281 : (('s, _menhir_box_file_parser) _menhir_cell1_AXIOM, _menhir_box_file_parser) _menhir_state
    (** State 281.
        Stack shape : AXIOM.
        Start symbol: file_parser. *)

  | MenhirState283 : ((('s, _menhir_box_file_parser) _menhir_cell1_AXIOM, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 283.
        Stack shape : AXIOM ident.
        Start symbol: file_parser. *)

  | MenhirState287 : (('s, _menhir_box_file_parser) _menhir_cell1_theory_elt, _menhir_box_file_parser) _menhir_state
    (** State 287.
        Stack shape : theory_elt.
        Start symbol: file_parser. *)

  | MenhirState289 : (('s, _menhir_box_file_parser) _menhir_cell1_REWRITING, _menhir_box_file_parser) _menhir_state
    (** State 289.
        Stack shape : REWRITING.
        Start symbol: file_parser. *)

  | MenhirState291 : ((('s, _menhir_box_file_parser) _menhir_cell1_REWRITING, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 291.
        Stack shape : REWRITING ident.
        Start symbol: file_parser. *)

  | MenhirState294 : (('s, _menhir_box_file_parser) _menhir_cell1_lexpr _menhir_cell0_PV, _menhir_box_file_parser) _menhir_state
    (** State 294.
        Stack shape : lexpr PV.
        Start symbol: file_parser. *)

  | MenhirState296 : (('s, _menhir_box_file_parser) _menhir_cell1_PRED, _menhir_box_file_parser) _menhir_state
    (** State 296.
        Stack shape : PRED.
        Start symbol: file_parser. *)

  | MenhirState298 : ((('s, _menhir_box_file_parser) _menhir_cell1_PRED, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR, _menhir_box_file_parser) _menhir_state
    (** State 298.
        Stack shape : PRED named_ident LEFTPAR.
        Start symbol: file_parser. *)

  | MenhirState300 : (('s, _menhir_box_file_parser) _menhir_cell1_logic_binder, _menhir_box_file_parser) _menhir_state
    (** State 300.
        Stack shape : logic_binder.
        Start symbol: file_parser. *)

  | MenhirState303 : (('s, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 303.
        Stack shape : ident.
        Start symbol: file_parser. *)

  | MenhirState304 : ((('s, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_primitive_type, _menhir_box_file_parser) _menhir_state
    (** State 304.
        Stack shape : ident primitive_type.
        Start symbol: file_parser. *)

  | MenhirState308 : (((('s, _menhir_box_file_parser) _menhir_cell1_PRED, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR, _menhir_box_file_parser) _menhir_cell1_list0_logic_binder_sep_comma _menhir_cell0_RIGHTPAR, _menhir_box_file_parser) _menhir_state
    (** State 308.
        Stack shape : PRED named_ident LEFTPAR list0_logic_binder_sep_comma RIGHTPAR.
        Start symbol: file_parser. *)

  | MenhirState310 : ((('s, _menhir_box_file_parser) _menhir_cell1_PRED, _menhir_box_file_parser) _menhir_cell1_named_ident, _menhir_box_file_parser) _menhir_state
    (** State 310.
        Stack shape : PRED named_ident.
        Start symbol: file_parser. *)

  | MenhirState314 : (('s, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_state
    (** State 314.
        Stack shape : LOGIC ac_modifier.
        Start symbol: file_parser. *)

  | MenhirState316 : ((('s, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma, _menhir_box_file_parser) _menhir_state
    (** State 316.
        Stack shape : LOGIC ac_modifier list1_named_ident_sep_comma.
        Start symbol: file_parser. *)

  | MenhirState318 : (((('s, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma, _menhir_box_file_parser) _menhir_cell1_primitive_type, _menhir_box_file_parser) _menhir_state
    (** State 318.
        Stack shape : LOGIC ac_modifier list1_named_ident_sep_comma primitive_type.
        Start symbol: file_parser. *)

  | MenhirState322 : (((('s, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma, _menhir_box_file_parser) _menhir_cell1_list0_primitive_type_sep_comma, _menhir_box_file_parser) _menhir_state
    (** State 322.
        Stack shape : LOGIC ac_modifier list1_named_ident_sep_comma list0_primitive_type_sep_comma.
        Start symbol: file_parser. *)

  | MenhirState324 : ((((('s, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma, _menhir_box_file_parser) _menhir_cell1_list0_primitive_type_sep_comma, _menhir_box_file_parser) _menhir_cell1_primitive_type, _menhir_box_file_parser) _menhir_state
    (** State 324.
        Stack shape : LOGIC ac_modifier list1_named_ident_sep_comma list0_primitive_type_sep_comma primitive_type.
        Start symbol: file_parser. *)

  | MenhirState325 : (('s, _menhir_box_file_parser) _menhir_cell1_GOAL, _menhir_box_file_parser) _menhir_state
    (** State 325.
        Stack shape : GOAL.
        Start symbol: file_parser. *)

  | MenhirState327 : ((('s, _menhir_box_file_parser) _menhir_cell1_GOAL, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 327.
        Stack shape : GOAL ident.
        Start symbol: file_parser. *)

  | MenhirState329 : (('s, _menhir_box_file_parser) _menhir_cell1_FUNC, _menhir_box_file_parser) _menhir_state
    (** State 329.
        Stack shape : FUNC.
        Start symbol: file_parser. *)

  | MenhirState331 : ((('s, _menhir_box_file_parser) _menhir_cell1_FUNC, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR, _menhir_box_file_parser) _menhir_state
    (** State 331.
        Stack shape : FUNC named_ident LEFTPAR.
        Start symbol: file_parser. *)

  | MenhirState334 : (((('s, _menhir_box_file_parser) _menhir_cell1_FUNC, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR, _menhir_box_file_parser) _menhir_cell1_list0_logic_binder_sep_comma _menhir_cell0_RIGHTPAR, _menhir_box_file_parser) _menhir_state
    (** State 334.
        Stack shape : FUNC named_ident LEFTPAR list0_logic_binder_sep_comma RIGHTPAR.
        Start symbol: file_parser. *)

  | MenhirState335 : ((((('s, _menhir_box_file_parser) _menhir_cell1_FUNC, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR, _menhir_box_file_parser) _menhir_cell1_list0_logic_binder_sep_comma _menhir_cell0_RIGHTPAR, _menhir_box_file_parser) _menhir_cell1_primitive_type, _menhir_box_file_parser) _menhir_state
    (** State 335.
        Stack shape : FUNC named_ident LEFTPAR list0_logic_binder_sep_comma RIGHTPAR primitive_type.
        Start symbol: file_parser. *)

  | MenhirState336 : (((((('s, _menhir_box_file_parser) _menhir_cell1_FUNC, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR, _menhir_box_file_parser) _menhir_cell1_list0_logic_binder_sep_comma _menhir_cell0_RIGHTPAR, _menhir_box_file_parser) _menhir_cell1_primitive_type, _menhir_box_file_parser) _menhir_cell1_EQUAL, _menhir_box_file_parser) _menhir_state
    (** State 336.
        Stack shape : FUNC named_ident LEFTPAR list0_logic_binder_sep_comma RIGHTPAR primitive_type EQUAL.
        Start symbol: file_parser. *)

  | MenhirState339 : (('s, _menhir_box_file_parser) _menhir_cell1_AXIOM, _menhir_box_file_parser) _menhir_state
    (** State 339.
        Stack shape : AXIOM.
        Start symbol: file_parser. *)

  | MenhirState341 : ((('s, _menhir_box_file_parser) _menhir_cell1_AXIOM, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_state
    (** State 341.
        Stack shape : AXIOM ident.
        Start symbol: file_parser. *)

  | MenhirState346 : (('s, _menhir_box_file_parser) _menhir_cell1_decl, _menhir_box_file_parser) _menhir_state
    (** State 346.
        Stack shape : decl.
        Start symbol: file_parser. *)

  | MenhirState348 : ('s, _menhir_box_lexpr_parser) _menhir_state
    (** State 348.
        Stack shape : .
        Start symbol: lexpr_parser. *)

  | MenhirState352 : ('s, _menhir_box_trigger_parser) _menhir_state
    (** State 352.
        Stack shape : .
        Start symbol: trigger_parser. *)


and 's _menhir_cell0_ac_modifier = 
  | MenhirCell0_ac_modifier of 's * (AltErgoLib.Symbols.name_kind)

and 's _menhir_cell0_algebraic_args = 
  | MenhirCell0_algebraic_args of 's * ((string * AltErgoLib.Parsed.ppure_type) list)

and ('s, 'r) _menhir_cell1_array_assignement = 
  | MenhirCell1_array_assignement of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.lexpr * AltErgoLib.Parsed.lexpr)

and ('s, 'r) _menhir_cell1_bound = 
  | MenhirCell1_bound of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.lexpr)

and ('s, 'r) _menhir_cell1_decl = 
  | MenhirCell1_decl of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.decl)

and ('s, 'r) _menhir_cell1_filters = 
  | MenhirCell1_filters of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.lexpr list)

and ('s, 'r) _menhir_cell1_ident = 
  | MenhirCell1_ident of 's * ('s, 'r) _menhir_state * (string) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_label_with_type = 
  | MenhirCell1_label_with_type of 's * ('s, 'r) _menhir_state * (string * AltErgoLib.Parsed.ppure_type)

and ('s, 'r) _menhir_cell1_let_binders = 
  | MenhirCell1_let_binders of 's * ('s, 'r) _menhir_state * ((string * AltErgoLib.Parsed.lexpr) list)

and ('s, 'r) _menhir_cell1_lexpr = 
  | MenhirCell1_lexpr of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.lexpr) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_lexpr_or_dom = 
  | MenhirCell1_lexpr_or_dom of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.lexpr)

and ('s, 'r) _menhir_cell1_list0_logic_binder_sep_comma = 
  | MenhirCell1_list0_logic_binder_sep_comma of 's * ('s, 'r) _menhir_state * ((AltErgoLib.Loc.t * string * AltErgoLib.Parsed.ppure_type) list)

and ('s, 'r) _menhir_cell1_list0_primitive_type_sep_comma = 
  | MenhirCell1_list0_primitive_type_sep_comma of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.ppure_type list)

and ('s, 'r) _menhir_cell1_list1_constructors_sep_bar = 
  | MenhirCell1_list1_constructors_sep_bar of 's * ('s, 'r) _menhir_state * ((string * (string * AltErgoLib.Parsed.ppure_type) list) list)

and ('s, 'r) _menhir_cell1_list1_match_cases = 
  | MenhirCell1_list1_match_cases of 's * ('s, 'r) _menhir_state * ((AltErgoLib.Parsed.pattern * AltErgoLib.Parsed.lexpr) list)

and ('s, 'r) _menhir_cell1_list1_multi_logic_binder = 
  | MenhirCell1_list1_multi_logic_binder of 's * ('s, 'r) _menhir_state * (((string * string) list * AltErgoLib.Parsed.ppure_type) list)

and ('s, 'r) _menhir_cell1_list1_named_ident_sep_comma = 
  | MenhirCell1_list1_named_ident_sep_comma of 's * ('s, 'r) _menhir_state * ((string * string) list)

and ('s, 'r) _menhir_cell1_list1_primitive_type_sep_comma = 
  | MenhirCell1_list1_primitive_type_sep_comma of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.ppure_type list)

and ('s, 'r) _menhir_cell1_logic_binder = 
  | MenhirCell1_logic_binder of 's * ('s, 'r) _menhir_state * (AltErgoLib.Loc.t * string * AltErgoLib.Parsed.ppure_type)

and ('s, 'r) _menhir_cell1_multi_logic_binder = 
  | MenhirCell1_multi_logic_binder of 's * ('s, 'r) _menhir_state * ((string * string) list * AltErgoLib.Parsed.ppure_type)

and ('s, 'r) _menhir_cell1_named_ident = 
  | MenhirCell1_named_ident of 's * ('s, 'r) _menhir_state * (string * string)

and ('s, 'r) _menhir_cell1_primitive_type = 
  | MenhirCell1_primitive_type of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.ppure_type) * Lexing.position

and ('s, 'r) _menhir_cell1_simple_expr = 
  | MenhirCell1_simple_expr of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.lexpr) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_simple_pattern = 
  | MenhirCell1_simple_pattern of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.pattern)

and ('s, 'r) _menhir_cell1_sq = 
  | MenhirCell1_sq of 's * ('s, 'r) _menhir_state * (bool) * Lexing.position

and ('s, 'r) _menhir_cell1_theory_elt = 
  | MenhirCell1_theory_elt of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.decl)

and ('s, 'r) _menhir_cell1_trigger = 
  | MenhirCell1_trigger of 's * ('s, 'r) _menhir_state * (AltErgoLib.Parsed.lexpr list * bool)

and ('s, 'r) _menhir_cell1_triggers = 
  | MenhirCell1_triggers of 's * ('s, 'r) _menhir_state * ((AltErgoLib.Parsed.lexpr list * bool) list)

and ('s, 'r) _menhir_cell1_type_var = 
  | MenhirCell1_type_var of 's * ('s, 'r) _menhir_state * (string) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_type_vars = 
  | MenhirCell1_type_vars of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_AND = 
  | MenhirCell1_AND of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_AND = 
  | MenhirCell0_AND of 's * Lexing.position

and ('s, 'r) _menhir_cell1_AXIOM = 
  | MenhirCell1_AXIOM of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_BAR = 
  | MenhirCell1_BAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_CASESPLIT = 
  | MenhirCell1_CASESPLIT of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_CHECK = 
  | MenhirCell1_CHECK of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_COMMA = 
  | MenhirCell1_COMMA of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_CUT = 
  | MenhirCell1_CUT of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_DISTINCT = 
  | MenhirCell1_DISTINCT of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_EQUAL = 
  | MenhirCell1_EQUAL of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_EXISTS = 
  | MenhirCell1_EXISTS of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_FORALL = 
  | MenhirCell1_FORALL of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_FUNC = 
  | MenhirCell1_FUNC of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_GOAL = 
  | MenhirCell1_GOAL of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_IF = 
  | MenhirCell1_IF of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_LEFTBR = 
  | MenhirCell1_LEFTBR of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_LEFTPAR = 
  | MenhirCell1_LEFTPAR of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_LEFTPAR = 
  | MenhirCell0_LEFTPAR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_LEFTSQ = 
  | MenhirCell1_LEFTSQ of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_LEFTSQ = 
  | MenhirCell0_LEFTSQ of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_LET = 
  | MenhirCell1_LET of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_LOGIC = 
  | MenhirCell1_LOGIC of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_MATCH = 
  | MenhirCell1_MATCH of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_MINUS = 
  | MenhirCell1_MINUS of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_MINUS = 
  | MenhirCell0_MINUS of 's * Lexing.position

and ('s, 'r) _menhir_cell1_NOT = 
  | MenhirCell1_NOT of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_PRED = 
  | MenhirCell1_PRED of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_PV = 
  | MenhirCell0_PV of 's * Lexing.position

and 's _menhir_cell0_QM = 
  | MenhirCell0_QM of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_QUOTE = 
  | MenhirCell1_QUOTE of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_REWRITING = 
  | MenhirCell1_REWRITING of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_RIGHTPAR = 
  | MenhirCell0_RIGHTPAR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_STRING = 
  | MenhirCell1_STRING of 's * ('s, 'r) _menhir_state * (
# 42 "src/parsers/native_parser.mly"
       (string)
# 995 "src/parsers/native_parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_THEORY = 
  | MenhirCell1_THEORY of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_TYPE = 
  | MenhirCell1_TYPE of 's * ('s, 'r) _menhir_state * Lexing.position

and _menhir_box_trigger_parser = 
  | MenhirBox_trigger_parser of (AltErgoLib.Parsed.lexpr list * bool) [@@unboxed]

and _menhir_box_lexpr_parser = 
  | MenhirBox_lexpr_parser of (AltErgoLib.Parsed.lexpr) [@@unboxed]

and _menhir_box_file_parser = 
  | MenhirBox_file_parser of (AltErgoLib.Parsed.file) [@@unboxed]

let _menhir_action_003 =
  fun () ->
    (
# 166 "src/parsers/native_parser.mly"
        ( Symbols.Other )
# 1018 "src/parsers/native_parser.ml"
     : (AltErgoLib.Symbols.name_kind))

let _menhir_action_004 =
  fun () ->
    (
# 167 "src/parsers/native_parser.mly"
        ( Symbols.Ac )
# 1026 "src/parsers/native_parser.ml"
     : (AltErgoLib.Symbols.name_kind))

let _menhir_action_005 =
  fun () ->
    (
# 226 "src/parsers/native_parser.mly"
  ( [] )
# 1034 "src/parsers/native_parser.ml"
     : ((string * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_006 =
  fun _2 ->
    (
# 227 "src/parsers/native_parser.mly"
                 ( _2 )
# 1042 "src/parsers/native_parser.ml"
     : ((string * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_007 =
  fun () ->
    (
# 230 "src/parsers/native_parser.mly"
    ( [] )
# 1050 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Loc.t * string list * string *
   (string * (string * AltErgoLib.Parsed.ppure_type) list) list)
  list))

let _menhir_action_008 =
  fun _endpos_others_ _startpos__1_ enum others ty ty_vars ->
    let _endpos = _endpos_others_ in
    let _startpos = _startpos__1_ in
    (
# 233 "src/parsers/native_parser.mly"
    ( ((_startpos, _endpos), ty_vars, ty, enum) :: others)
# 1062 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Loc.t * string list * string *
   (string * (string * AltErgoLib.Parsed.ppure_type) list) list)
  list))

let _menhir_action_009 =
  fun e1 e2 ->
    (
# 436 "src/parsers/native_parser.mly"
                                   ( e1, e2 )
# 1072 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr * AltErgoLib.Parsed.lexpr))

let _menhir_action_010 =
  fun assign ->
    (
# 431 "src/parsers/native_parser.mly"
   ( [assign] )
# 1080 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Parsed.lexpr * AltErgoLib.Parsed.lexpr) list))

let _menhir_action_011 =
  fun assign assign_l ->
    (
# 433 "src/parsers/native_parser.mly"
   ( assign :: assign_l )
# 1088 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Parsed.lexpr * AltErgoLib.Parsed.lexpr) list))

let _menhir_action_012 =
  fun _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    (
# 490 "src/parsers/native_parser.mly"
                     ( mk_var (_startpos, _endpos) "?" )
# 1098 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_013 =
  fun _endpos_id_ _startpos_id_ id ->
    let _endpos = _endpos_id_ in
    let _startpos = _startpos_id_ in
    (
# 491 "src/parsers/native_parser.mly"
                     ( mk_var (_startpos, _endpos) id )
# 1108 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_014 =
  fun _endpos_id_ _startpos_id_ id ->
    let _endpos = _endpos_id_ in
    let _startpos = _startpos_id_ in
    (
# 492 "src/parsers/native_parser.mly"
                     ( mk_var (_startpos, _endpos) id )
# 1118 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_015 =
  fun _endpos_i_ _startpos_i_ i ->
    let _endpos = _endpos_i_ in
    let _startpos = _startpos_i_ in
    (
# 493 "src/parsers/native_parser.mly"
                     ( mk_int_const (_startpos, _endpos) i )
# 1128 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_016 =
  fun _endpos_i_ _startpos_i_ i ->
    let _endpos = _endpos_i_ in
    let _startpos = _startpos_i_ in
    (
# 494 "src/parsers/native_parser.mly"
                     ( mk_real_const (_startpos, _endpos) i )
# 1138 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_017 =
  fun _endpos_i_ _startpos__1_ i ->
    let _endpos = _endpos_i_ in
    let _startpos = _startpos__1_ in
    (
# 495 "src/parsers/native_parser.mly"
                     ( mk_int_const (_startpos, _endpos) i )
# 1148 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_018 =
  fun _endpos_i_ _startpos__1_ i ->
    let _endpos = _endpos_i_ in
    let _startpos = _startpos__1_ in
    (
# 496 "src/parsers/native_parser.mly"
                     ( mk_real_const (_startpos, _endpos) i )
# 1158 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_019 =
  fun _endpos__7_ _startpos__1_ th_body th_ext th_id ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos__1_ in
    (
# 102 "src/parsers/native_parser.mly"
   ( mk_theory (_startpos, _endpos) th_id th_ext th_body )
# 1168 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_020 =
  fun _endpos_ty_ _startpos__1_ ty ty_vars ->
    let _endpos = _endpos_ty_ in
    let _startpos = _startpos__1_ in
    (
# 105 "src/parsers/native_parser.mly"
    ( mk_abstract_type_decl (_startpos, _endpos) ty_vars ty )
# 1178 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_021 =
  fun _endpos_others_ _startpos__1_ enum others ty ty_vars ->
    let _endpos = _endpos_others_ in
    let _startpos = _startpos__1_ in
    (
# 109 "src/parsers/native_parser.mly"
    (
      match others with
        | [] ->
           mk_algebraic_type_decl (_startpos, _endpos) ty_vars ty enum
        | l ->
           let l = ((_startpos, _endpos), ty_vars, ty, enum) :: l in
           let l =
             List.map
               (fun (a, b, c, d) ->
                 match mk_algebraic_type_decl a b c d with
                 | Parsed.TypeDecl [e] -> e
                 | _ -> assert false
               ) l
           in
           mk_rec_type_decl l
    )
# 1203 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_022 =
  fun _endpos_record_ _startpos__1_ record ty ty_vars ->
    let _endpos = _endpos_record_ in
    let _startpos = _startpos__1_ in
    (
# 127 "src/parsers/native_parser.mly"
   ( mk_record_type_decl (_startpos, _endpos) ty_vars ty record )
# 1213 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_023 =
  fun _endpos_ty_ _startpos__1_ ids is_ac ty ->
    let _endpos = _endpos_ty_ in
    let _startpos = _startpos__1_ in
    (
# 131 "src/parsers/native_parser.mly"
   ( mk_logic (_startpos, _endpos) is_ac ids ty )
# 1223 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_024 =
  fun _endpos_body_ _startpos__1_ app args body ret_ty ->
    let _endpos = _endpos_body_ in
    let _startpos = _startpos__1_ in
    (
# 135 "src/parsers/native_parser.mly"
   ( mk_function_def (_startpos, _endpos) app args ret_ty body )
# 1233 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_025 =
  fun _endpos_body_ _startpos__1_ app body ->
    let _endpos = _endpos_body_ in
    let _startpos = _startpos__1_ in
    (
# 138 "src/parsers/native_parser.mly"
   ( mk_ground_predicate_def (_startpos, _endpos) app body )
# 1243 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_026 =
  fun _endpos_body_ _startpos__1_ app args body ->
    let _endpos = _endpos_body_ in
    let _startpos = _startpos__1_ in
    (
# 142 "src/parsers/native_parser.mly"
   ( mk_non_ground_predicate_def (_startpos, _endpos) app args body )
# 1253 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_027 =
  fun _endpos_body_ _startpos__1_ body name ->
    let _endpos = _endpos_body_ in
    let _startpos = _startpos__1_ in
    (
# 145 "src/parsers/native_parser.mly"
   ( mk_generic_axiom (_startpos, _endpos) name body )
# 1263 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_028 =
  fun _endpos_body_ _startpos__1_ body name ->
    let _endpos = _endpos_body_ in
    let _startpos = _startpos__1_ in
    (
# 148 "src/parsers/native_parser.mly"
   ( mk_rewriting (_startpos, _endpos) name body )
# 1273 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_029 =
  fun _endpos_body_ _startpos__1_ body name ->
    let _endpos = _endpos_body_ in
    let _startpos = _startpos__1_ in
    (
# 151 "src/parsers/native_parser.mly"
   ( mk_goal (_startpos, _endpos) name body )
# 1283 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_030 =
  fun decls ->
    (
# 87 "src/parsers/native_parser.mly"
                         ( decls )
# 1291 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.file))

let _menhir_action_031 =
  fun () ->
    (
# 88 "src/parsers/native_parser.mly"
      ( [] )
# 1299 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.file))

let _menhir_action_032 =
  fun () ->
    (
# 445 "src/parsers/native_parser.mly"
    ( [] )
# 1307 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_033 =
  fun filt ->
    (
# 447 "src/parsers/native_parser.mly"
   ( [filt] )
# 1315 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_034 =
  fun filt filt_l ->
    (
# 449 "src/parsers/native_parser.mly"
   ( filt :: filt_l )
# 1323 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_035 =
  fun id ->
    (
# 532 "src/parsers/native_parser.mly"
          ( id )
# 1331 "src/parsers/native_parser.ml"
     : (string))

let _menhir_action_036 =
  fun id ty ->
    (
# 510 "src/parsers/native_parser.mly"
                                       ( id, ty )
# 1339 "src/parsers/native_parser.ml"
     : (string * AltErgoLib.Parsed.ppure_type))

let _menhir_action_037 =
  fun binder e ->
    (
# 372 "src/parsers/native_parser.mly"
                                 ( [binder, e] )
# 1347 "src/parsers/native_parser.ml"
     : ((string * AltErgoLib.Parsed.lexpr) list))

let _menhir_action_038 =
  fun binder e l ->
    (
# 373 "src/parsers/native_parser.mly"
                                                       ( (binder, e) :: l )
# 1355 "src/parsers/native_parser.ml"
     : ((string * AltErgoLib.Parsed.lexpr) list))

let _menhir_action_039 =
  fun se ->
    (
# 237 "src/parsers/native_parser.mly"
                   ( se )
# 1363 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_040 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 242 "src/parsers/native_parser.mly"
   ( mk_add (_startpos, _endpos) se1 se2 )
# 1373 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_041 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 245 "src/parsers/native_parser.mly"
   ( mk_sub (_startpos, _endpos) se1 se2 )
# 1383 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_042 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 248 "src/parsers/native_parser.mly"
   ( mk_mul (_startpos, _endpos) se1 se2 )
# 1393 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_043 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 251 "src/parsers/native_parser.mly"
   ( mk_div (_startpos, _endpos) se1 se2 )
# 1403 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_044 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 254 "src/parsers/native_parser.mly"
   ( mk_mod (_startpos, _endpos) se1 se2 )
# 1413 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_045 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 257 "src/parsers/native_parser.mly"
   ( mk_pow_int (_startpos, _endpos) se1 se2 )
# 1423 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_046 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 260 "src/parsers/native_parser.mly"
   ( mk_pow_real (_startpos, _endpos) se1 se2 )
# 1433 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_047 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 263 "src/parsers/native_parser.mly"
   ( mk_and (_startpos, _endpos) se1 se2 )
# 1443 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_048 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 266 "src/parsers/native_parser.mly"
   ( mk_or (_startpos, _endpos) se1 se2 )
# 1453 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_049 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 269 "src/parsers/native_parser.mly"
   ( mk_xor (_startpos, _endpos) se1 se2 )
# 1463 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_050 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 272 "src/parsers/native_parser.mly"
   ( mk_iff (_startpos, _endpos) se1 se2 )
# 1473 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_051 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 275 "src/parsers/native_parser.mly"
   ( mk_implies (_startpos, _endpos) se1 se2 )
# 1483 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_052 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 278 "src/parsers/native_parser.mly"
   ( mk_pred_lt (_startpos, _endpos) se1 se2 )
# 1493 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_053 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 281 "src/parsers/native_parser.mly"
   ( mk_pred_le (_startpos, _endpos) se1 se2 )
# 1503 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_054 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 284 "src/parsers/native_parser.mly"
   ( mk_pred_gt (_startpos, _endpos) se1 se2 )
# 1513 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_055 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 287 "src/parsers/native_parser.mly"
   ( mk_pred_ge (_startpos, _endpos) se1 se2 )
# 1523 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_056 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 290 "src/parsers/native_parser.mly"
   ( mk_pred_eq (_startpos, _endpos) se1 se2 )
# 1533 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_057 =
  fun _endpos_se2_ _startpos_se1_ se1 se2 ->
    let _endpos = _endpos_se2_ in
    let _startpos = _startpos_se1_ in
    (
# 293 "src/parsers/native_parser.mly"
   ( mk_pred_not_eq (_startpos, _endpos) se1 se2 )
# 1543 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_058 =
  fun _endpos_se_ _startpos__1_ se ->
    let _endpos = _endpos_se_ in
    let _startpos = _startpos__1_ in
    (
# 296 "src/parsers/native_parser.mly"
   ( mk_not (_startpos, _endpos) se )
# 1553 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_059 =
  fun _endpos_se_ _startpos__1_ se ->
    let _endpos = _endpos_se_ in
    let _startpos = _startpos__1_ in
    (
# 299 "src/parsers/native_parser.mly"
   ( mk_minus (_startpos, _endpos) se )
# 1563 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_060 =
  fun _endpos__5_ _startpos__1_ bv_cst ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    (
# 304 "src/parsers/native_parser.mly"
    ( mk_bitv_const (_startpos, _endpos) bv_cst )
# 1573 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_061 =
  fun _endpos__7_ _startpos_e_ e i j ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos_e_ in
    (
# 307 "src/parsers/native_parser.mly"
   ( mk_bitv_extract (_startpos, _endpos) e i j )
# 1583 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_062 =
  fun _endpos_e2_ _startpos_e1_ e1 e2 ->
    let _endpos = _endpos_e2_ in
    let _startpos = _startpos_e1_ in
    (
# 310 "src/parsers/native_parser.mly"
   ( mk_bitv_concat (_startpos, _endpos) e1 e2 )
# 1593 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_063 =
  fun _endpos__4_ _startpos__1_ dist_l ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    (
# 315 "src/parsers/native_parser.mly"
   ( mk_distinct (_startpos, _endpos) dist_l )
# 1603 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_064 =
  fun _endpos_br2_ _startpos__1_ br1 br2 cond ->
    let _endpos = _endpos_br2_ in
    let _startpos = _startpos__1_ in
    (
# 318 "src/parsers/native_parser.mly"
   ( mk_ite (_startpos, _endpos) cond br1 br2 )
# 1613 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_065 =
  fun _endpos_body_ _startpos__1_ body filters quant_vars triggers ->
    let _endpos = _endpos_body_ in
    let _startpos = _startpos__1_ in
    (
# 322 "src/parsers/native_parser.mly"
   (
     let vs_ty =
       List.map (fun (vs, ty) ->
         List.map (fun (v, name) -> v, name, ty) vs) quant_vars
     in
     let vs_ty = List.flatten vs_ty in
     mk_forall (_startpos, _endpos) vs_ty triggers filters body
   )
# 1630 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_066 =
  fun _endpos_body_ _startpos__1_ body filters quant_vars triggers ->
    let _endpos = _endpos_body_ in
    let _startpos = _startpos__1_ in
    (
# 333 "src/parsers/native_parser.mly"
   (
     let vs_ty =
       List.map (fun (vs, ty) ->
         List.map (fun (v, name) -> v, name, ty) vs) quant_vars
     in
     let vs_ty = List.flatten vs_ty in
     mk_exists (_startpos, _endpos) vs_ty triggers filters body
   )
# 1647 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_067 =
  fun _endpos_e_ _startpos_name_ e name ->
    let _endpos = _endpos_e_ in
    let _startpos = _startpos_name_ in
    (
# 343 "src/parsers/native_parser.mly"
   ( mk_named (_startpos, _endpos) name e )
# 1657 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_068 =
  fun _endpos_e2_ _startpos__1_ binders e2 ->
    let _endpos = _endpos_e2_ in
    let _startpos = _startpos__1_ in
    (
# 346 "src/parsers/native_parser.mly"
   ( mk_let (_startpos, _endpos) binders e2 )
# 1667 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_069 =
  fun _endpos_e_ _startpos__1_ e ->
    let _endpos = _endpos_e_ in
    let _startpos = _startpos__1_ in
    (
# 349 "src/parsers/native_parser.mly"
   ( mk_check (_startpos, _endpos) e )
# 1677 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_070 =
  fun _endpos_e_ _startpos__1_ e ->
    let _endpos = _endpos_e_ in
    let _startpos = _startpos__1_ in
    (
# 352 "src/parsers/native_parser.mly"
   ( mk_cut (_startpos, _endpos) e )
# 1687 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_071 =
  fun _endpos__5_ _startpos__1_ cases e ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    (
# 356 "src/parsers/native_parser.mly"
    ( mk_match (_startpos, _endpos) e (List.rev cases) )
# 1697 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_072 =
  fun e ->
    (
# 478 "src/parsers/native_parser.mly"
   ( e )
# 1705 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_073 =
  fun _endpos_rbr_ _startpos_e_ e lbnd lbr rbnd rbr ->
    let _endpos = _endpos_rbr_ in
    let _startpos = _startpos_e_ in
    (
# 480 "src/parsers/native_parser.mly"
   ( mk_in_interval (_startpos, _endpos) e lbr lbnd rbnd rbr )
# 1715 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_074 =
  fun _endpos_e_ _startpos_id_ e id ->
    let _endpos = _endpos_e_ in
    let _startpos = _startpos_id_ in
    (
# 482 "src/parsers/native_parser.mly"
   ( mk_maps_to (_startpos, _endpos) id e )
# 1725 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_075 =
  fun e ->
    (
# 94 "src/parsers/native_parser.mly"
                ( e )
# 1733 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_076 =
  fun () ->
    (
# 465 "src/parsers/native_parser.mly"
                        ( [] )
# 1741 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_077 =
  fun l ->
    (
# 466 "src/parsers/native_parser.mly"
                            ( l )
# 1749 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_078 =
  fun () ->
    (
# 207 "src/parsers/native_parser.mly"
                                           ( [] )
# 1757 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Loc.t * string * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_079 =
  fun binders_l ->
    (
# 208 "src/parsers/native_parser.mly"
                                           ( binders_l )
# 1765 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Loc.t * string * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_080 =
  fun () ->
    (
# 203 "src/parsers/native_parser.mly"
                                        ( [] )
# 1773 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type list))

let _menhir_action_081 =
  fun ty_l ->
    (
# 204 "src/parsers/native_parser.mly"
                                        ( ty_l )
# 1781 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type list))

let _menhir_action_082 =
  fun _2 cons ->
    (
# 221 "src/parsers/native_parser.mly"
                              ( [cons, _2] )
# 1789 "src/parsers/native_parser.ml"
     : ((string * (string * AltErgoLib.Parsed.ppure_type) list) list))

let _menhir_action_083 =
  fun _2 cons cons_l ->
    (
# 223 "src/parsers/native_parser.mly"
                                             ( (cons, _2) :: cons_l )
# 1797 "src/parsers/native_parser.ml"
     : ((string * (string * AltErgoLib.Parsed.ppure_type) list) list))

let _menhir_action_084 =
  fun decl ->
    (
# 97 "src/parsers/native_parser.mly"
              ( [decl] )
# 1805 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.file))

let _menhir_action_085 =
  fun decl decls ->
    (
# 98 "src/parsers/native_parser.mly"
                                 ( decl :: decls )
# 1813 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.file))

let _menhir_action_086 =
  fun e id ->
    (
# 515 "src/parsers/native_parser.mly"
   ( [id, e] )
# 1821 "src/parsers/native_parser.ml"
     : ((string * AltErgoLib.Parsed.lexpr) list))

let _menhir_action_087 =
  fun e id l ->
    (
# 517 "src/parsers/native_parser.mly"
   ( (id, e) :: l )
# 1829 "src/parsers/native_parser.ml"
     : ((string * AltErgoLib.Parsed.lexpr) list))

let _menhir_action_088 =
  fun label_typed ->
    (
# 506 "src/parsers/native_parser.mly"
                                                        ( [label_typed] )
# 1837 "src/parsers/native_parser.ml"
     : ((string * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_089 =
  fun list_lt lt ->
    (
# 507 "src/parsers/native_parser.mly"
                                                         ( lt :: list_lt )
# 1845 "src/parsers/native_parser.ml"
     : ((string * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_090 =
  fun ed ->
    (
# 473 "src/parsers/native_parser.mly"
                                                ( [ed] )
# 1853 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_091 =
  fun ed edl ->
    (
# 474 "src/parsers/native_parser.mly"
                                                             ( ed :: edl )
# 1861 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_092 =
  fun e ->
    (
# 469 "src/parsers/native_parser.mly"
                                            ( [e] )
# 1869 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_093 =
  fun e l ->
    (
# 470 "src/parsers/native_parser.mly"
                                            ( e :: l )
# 1877 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_094 =
  fun e ->
    (
# 460 "src/parsers/native_parser.mly"
                                         ( [e] )
# 1885 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_095 =
  fun e ->
    (
# 461 "src/parsers/native_parser.mly"
                                         ( [e] )
# 1893 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_096 =
  fun e e_l ->
    (
# 462 "src/parsers/native_parser.mly"
                                         ( e :: e_l )
# 1901 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_097 =
  fun binder ->
    (
# 212 "src/parsers/native_parser.mly"
   ( [binder] )
# 1909 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Loc.t * string * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_098 =
  fun binder binders_list ->
    (
# 214 "src/parsers/native_parser.mly"
   ( binder :: binders_list )
# 1917 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Loc.t * string * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_099 =
  fun e p ->
    (
# 360 "src/parsers/native_parser.mly"
                                              ( [p, e])
# 1925 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Parsed.pattern * AltErgoLib.Parsed.lexpr) list))

let _menhir_action_100 =
  fun e p ->
    (
# 361 "src/parsers/native_parser.mly"
                                              ( [p, e])
# 1933 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Parsed.pattern * AltErgoLib.Parsed.lexpr) list))

let _menhir_action_101 =
  fun e l p ->
    (
# 363 "src/parsers/native_parser.mly"
    ( (p,e) :: l )
# 1941 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Parsed.pattern * AltErgoLib.Parsed.lexpr) list))

let _menhir_action_102 =
  fun binders ->
    (
# 540 "src/parsers/native_parser.mly"
   ( [binders] )
# 1949 "src/parsers/native_parser.ml"
     : (((string * string) list * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_103 =
  fun binders l ->
    (
# 542 "src/parsers/native_parser.mly"
   ( binders :: l )
# 1957 "src/parsers/native_parser.ml"
     : (((string * string) list * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_104 =
  fun id ->
    (
# 545 "src/parsers/native_parser.mly"
                                                     ( [id] )
# 1965 "src/parsers/native_parser.ml"
     : ((string * string) list))

let _menhir_action_105 =
  fun id l ->
    (
# 546 "src/parsers/native_parser.mly"
                                                                ( id :: l )
# 1973 "src/parsers/native_parser.ml"
     : ((string * string) list))

let _menhir_action_106 =
  fun ty ->
    (
# 199 "src/parsers/native_parser.mly"
                                                           ( [ty] )
# 1981 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type list))

let _menhir_action_107 =
  fun ty ty_l ->
    (
# 200 "src/parsers/native_parser.mly"
                                                                  ( ty::ty_l )
# 1989 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type list))

let _menhir_action_108 =
  fun id ->
    (
# 550 "src/parsers/native_parser.mly"
    ( [ id ] )
# 1997 "src/parsers/native_parser.ml"
     : (string list))

let _menhir_action_109 =
  fun id l ->
    (
# 551 "src/parsers/native_parser.mly"
                                              ( id :: l  )
# 2005 "src/parsers/native_parser.ml"
     : (string list))

let _menhir_action_110 =
  fun trig ->
    (
# 452 "src/parsers/native_parser.mly"
                 ( [trig] )
# 2013 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Parsed.lexpr list * bool) list))

let _menhir_action_111 =
  fun trig trigs ->
    (
# 453 "src/parsers/native_parser.mly"
                                                   ( trig :: trigs )
# 2021 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Parsed.lexpr list * bool) list))

let _menhir_action_112 =
  fun alpha ->
    (
# 528 "src/parsers/native_parser.mly"
                                                  ( [alpha] )
# 2029 "src/parsers/native_parser.ml"
     : (string list))

let _menhir_action_113 =
  fun alpha l ->
    (
# 529 "src/parsers/native_parser.mly"
                                                                ( alpha :: l )
# 2037 "src/parsers/native_parser.ml"
     : (string list))

let _menhir_action_114 =
  fun e1 e2 ->
    (
# 499 "src/parsers/native_parser.mly"
                                              ( [e1; e2] )
# 2045 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_115 =
  fun e el ->
    (
# 500 "src/parsers/native_parser.mly"
                                              ( e :: el   )
# 2053 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list))

let _menhir_action_116 =
  fun _endpos_id_ _startpos_id_ id ty ->
    (
# 218 "src/parsers/native_parser.mly"
    ( ((_startpos_id_, _endpos_id_), id, ty) )
# 2061 "src/parsers/native_parser.ml"
     : (AltErgoLib.Loc.t * string * AltErgoLib.Parsed.ppure_type))

let _menhir_action_117 =
  fun ty_list ->
    (
# 188 "src/parsers/native_parser.mly"
   ( mk_logic_type ty_list None )
# 2069 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.plogic_type))

let _menhir_action_118 =
  fun () ->
    (
# 190 "src/parsers/native_parser.mly"
       ( mk_logic_type [] None )
# 2077 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.plogic_type))

let _menhir_action_119 =
  fun ret_ty ty_list ->
    (
# 193 "src/parsers/native_parser.mly"
   ( mk_logic_type ty_list (Some ret_ty) )
# 2085 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.plogic_type))

let _menhir_action_120 =
  fun ret_ty ->
    (
# 196 "src/parsers/native_parser.mly"
   ( mk_logic_type [] (Some ret_ty) )
# 2093 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.plogic_type))

let _menhir_action_121 =
  fun binders ty ->
    (
# 536 "src/parsers/native_parser.mly"
    ( binders, ty )
# 2101 "src/parsers/native_parser.ml"
     : ((string * string) list * AltErgoLib.Parsed.ppure_type))

let _menhir_action_122 =
  fun id ->
    (
# 554 "src/parsers/native_parser.mly"
          ( id, "" )
# 2109 "src/parsers/native_parser.ml"
     : (string * string))

let _menhir_action_123 =
  fun id str ->
    (
# 555 "src/parsers/native_parser.mly"
                       ( id, str )
# 2117 "src/parsers/native_parser.ml"
     : (string * string))

let _menhir_action_124 =
  fun () ->
    (
# 170 "src/parsers/native_parser.mly"
       ( int_type )
# 2125 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type))

let _menhir_action_125 =
  fun () ->
    (
# 171 "src/parsers/native_parser.mly"
       ( bool_type )
# 2133 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type))

let _menhir_action_126 =
  fun () ->
    (
# 172 "src/parsers/native_parser.mly"
       ( real_type )
# 2141 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type))

let _menhir_action_127 =
  fun () ->
    (
# 173 "src/parsers/native_parser.mly"
       ( unit_type )
# 2149 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type))

let _menhir_action_128 =
  fun sz ->
    (
# 174 "src/parsers/native_parser.mly"
                                   ( mk_bitv_type sz )
# 2157 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type))

let _menhir_action_129 =
  fun _endpos_ext_ty_ _startpos_ext_ty_ ext_ty ->
    let _endpos = _endpos_ext_ty_ in
    let _startpos = _startpos_ext_ty_ in
    (
# 176 "src/parsers/native_parser.mly"
                 ( mk_external_type (_startpos, _endpos) [] ext_ty )
# 2167 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type))

let _menhir_action_130 =
  fun _endpos_alpha_ _startpos_alpha_ alpha ->
    let _endpos = _endpos_alpha_ in
    let _startpos = _startpos_alpha_ in
    (
# 178 "src/parsers/native_parser.mly"
                   ( mk_var_type (_startpos, _endpos) alpha )
# 2177 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type))

let _menhir_action_131 =
  fun _endpos_ext_ty_ _startpos_ext_ty_ ext_ty par ->
    (
# 181 "src/parsers/native_parser.mly"
   ( mk_external_type (_startpos_ext_ty_, _endpos_ext_ty_) [par] ext_ty )
# 2185 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type))

let _menhir_action_132 =
  fun _endpos_ext_ty_ _startpos_ext_ty_ ext_ty pars ->
    (
# 184 "src/parsers/native_parser.mly"
   ( mk_external_type (_startpos_ext_ty_, _endpos_ext_ty_) pars ext_ty )
# 2193 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.ppure_type))

let _menhir_action_133 =
  fun labels ->
    (
# 503 "src/parsers/native_parser.mly"
                                             ( labels )
# 2201 "src/parsers/native_parser.ml"
     : ((string * AltErgoLib.Parsed.ppure_type) list))

let _menhir_action_134 =
  fun _endpos_i_ _startpos_i_ i ->
    let _endpos = _endpos_i_ in
    let _startpos = _startpos_i_ in
    (
# 376 "src/parsers/native_parser.mly"
              ( mk_int_const (_startpos, _endpos) i )
# 2211 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_135 =
  fun _endpos_i_ _startpos_i_ i ->
    let _endpos = _endpos_i_ in
    let _startpos = _startpos_i_ in
    (
# 377 "src/parsers/native_parser.mly"
              ( mk_real_const (_startpos, _endpos) i )
# 2221 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_136 =
  fun _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    (
# 378 "src/parsers/native_parser.mly"
              ( mk_true_const (_startpos, _endpos) )
# 2231 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_137 =
  fun _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    (
# 379 "src/parsers/native_parser.mly"
              ( mk_false_const (_startpos, _endpos) )
# 2241 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_138 =
  fun _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    (
# 380 "src/parsers/native_parser.mly"
              ( mk_void (_startpos, _endpos) )
# 2251 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_139 =
  fun _endpos_var_ _startpos_var_ var ->
    let _endpos = _endpos_var_ in
    let _startpos = _startpos_var_ in
    (
# 381 "src/parsers/native_parser.mly"
              ( mk_var (_startpos, _endpos) var )
# 2261 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_140 =
  fun _endpos__3_ _startpos__1_ labels ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    (
# 386 "src/parsers/native_parser.mly"
   ( mk_record (_startpos, _endpos) labels )
# 2271 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_141 =
  fun _endpos__5_ _startpos__1_ labels se ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    (
# 389 "src/parsers/native_parser.mly"
   ( mk_with_record (_startpos, _endpos) se labels )
# 2281 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_142 =
  fun _endpos_label_ _startpos_se_ label se ->
    let _endpos = _endpos_label_ in
    let _startpos = _startpos_se_ in
    (
# 392 "src/parsers/native_parser.mly"
   ( mk_dot_record (_startpos, _endpos) se label )
# 2291 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_143 =
  fun _endpos__4_ _startpos_app_ app args ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos_app_ in
    (
# 397 "src/parsers/native_parser.mly"
   ( mk_application (_startpos, _endpos) app args )
# 2301 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_144 =
  fun _endpos__4_ _startpos_se_ e se ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos_se_ in
    (
# 402 "src/parsers/native_parser.mly"
   ( mk_array_get (_startpos, _endpos) se e )
# 2311 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_145 =
  fun _endpos__4_ _startpos_se_ assigns se ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos_se_ in
    (
# 405 "src/parsers/native_parser.mly"
    (
      let acc, l =
        match assigns with
	| [] -> assert false
	| (i, v)::l -> mk_array_set (_startpos, _endpos) se i v, l
      in
      List.fold_left (fun acc (i,v) ->
          mk_array_set (_startpos, _endpos) acc i v) acc l
    )
# 2329 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_146 =
  fun e ->
    (
# 416 "src/parsers/native_parser.mly"
   ( e )
# 2337 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_147 =
  fun _endpos_ty_ _startpos_se_ se ty ->
    let _endpos = _endpos_ty_ in
    let _startpos = _startpos_se_ in
    (
# 419 "src/parsers/native_parser.mly"
    (  mk_type_cast (_startpos, _endpos) se ty )
# 2347 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_148 =
  fun _endpos_id_ _startpos_se_ id se ->
    let _endpos = _endpos_id_ in
    let _startpos = _startpos_se_ in
    (
# 422 "src/parsers/native_parser.mly"
    ( mk_algebraic_test (_startpos, _endpos) se id )
# 2357 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_149 =
  fun _endpos_id_ _startpos_se_ id se ->
    let _endpos = _endpos_id_ in
    let _startpos = _startpos_se_ in
    (
# 425 "src/parsers/native_parser.mly"
    ( mk_algebraic_test (_startpos, _endpos) se id )
# 2367 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_150 =
  fun _endpos_label_ _startpos_se_ label se ->
    let _endpos = _endpos_label_ in
    let _startpos = _startpos_se_ in
    (
# 428 "src/parsers/native_parser.mly"
   ( mk_algebraic_project (_startpos, _endpos) ~guarded:true se label )
# 2377 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr))

let _menhir_action_151 =
  fun _endpos_id_ _startpos_id_ id ->
    let _endpos = _endpos_id_ in
    let _startpos = _startpos_id_ in
    (
# 366 "src/parsers/native_parser.mly"
             ( mk_pattern (_startpos, _endpos) id [] )
# 2387 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.pattern))

let _menhir_action_152 =
  fun _endpos__4_ _startpos_app_ app args ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos_app_ in
    (
# 368 "src/parsers/native_parser.mly"
   ( mk_pattern (_startpos, _endpos) app args )
# 2397 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.pattern))

let _menhir_action_153 =
  fun () ->
    (
# 486 "src/parsers/native_parser.mly"
         (true)
# 2405 "src/parsers/native_parser.ml"
     : (bool))

let _menhir_action_154 =
  fun () ->
    (
# 487 "src/parsers/native_parser.mly"
          (false)
# 2413 "src/parsers/native_parser.ml"
     : (bool))

let _menhir_action_155 =
  fun _endpos_body_ _startpos__1_ body name ->
    let _endpos = _endpos_body_ in
    let _startpos = _startpos__1_ in
    (
# 159 "src/parsers/native_parser.mly"
   ( mk_theory_axiom (_startpos, _endpos) name body )
# 2423 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_156 =
  fun _endpos_body_ _startpos__1_ body name ->
    let _endpos = _endpos_body_ in
    let _startpos = _startpos__1_ in
    (
# 162 "src/parsers/native_parser.mly"
   ( mk_theory_case_split (_startpos, _endpos) name body )
# 2433 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl))

let _menhir_action_157 =
  fun () ->
    (
# 154 "src/parsers/native_parser.mly"
         ( [] )
# 2441 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl list))

let _menhir_action_158 =
  fun th_elt th_rest ->
    (
# 155 "src/parsers/native_parser.mly"
                                            ( th_elt :: th_rest )
# 2449 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.decl list))

let _menhir_action_159 =
  fun terms ->
    (
# 457 "src/parsers/native_parser.mly"
   ( terms, true (* true <-> user-given trigger *) )
# 2457 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list * bool))

let _menhir_action_160 =
  fun trigger ->
    (
# 91 "src/parsers/native_parser.mly"
                        ( trigger )
# 2465 "src/parsers/native_parser.ml"
     : (AltErgoLib.Parsed.lexpr list * bool))

let _menhir_action_161 =
  fun () ->
    (
# 439 "src/parsers/native_parser.mly"
                                        ( [] )
# 2473 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Parsed.lexpr list * bool) list))

let _menhir_action_162 =
  fun trigs ->
    (
# 440 "src/parsers/native_parser.mly"
                                                ( trigs )
# 2481 "src/parsers/native_parser.ml"
     : ((AltErgoLib.Parsed.lexpr list * bool) list))

let _menhir_action_163 =
  fun alpha ->
    (
# 520 "src/parsers/native_parser.mly"
                      ( alpha )
# 2489 "src/parsers/native_parser.ml"
     : (string))

let _menhir_action_164 =
  fun () ->
    (
# 523 "src/parsers/native_parser.mly"
            ( [] )
# 2497 "src/parsers/native_parser.ml"
     : (string list))

let _menhir_action_165 =
  fun alpha ->
    (
# 524 "src/parsers/native_parser.mly"
                    ( [alpha] )
# 2505 "src/parsers/native_parser.ml"
     : (string list))

let _menhir_action_166 =
  fun l ->
    (
# 525 "src/parsers/native_parser.mly"
                                                ( l )
# 2513 "src/parsers/native_parser.ml"
     : (string list))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | AC ->
        "AC"
    | AND ->
        "AND"
    | AT ->
        "AT"
    | AXIOM ->
        "AXIOM"
    | BAR ->
        "BAR"
    | BITV ->
        "BITV"
    | BOOL ->
        "BOOL"
    | CASESPLIT ->
        "CASESPLIT"
    | CHECK ->
        "CHECK"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | CUT ->
        "CUT"
    | DISTINCT ->
        "DISTINCT"
    | DOT ->
        "DOT"
    | ELSE ->
        "ELSE"
    | END ->
        "END"
    | EOF ->
        "EOF"
    | EQUAL ->
        "EQUAL"
    | EXISTS ->
        "EXISTS"
    | EXTENDS ->
        "EXTENDS"
    | FALSE ->
        "FALSE"
    | FORALL ->
        "FORALL"
    | FUNC ->
        "FUNC"
    | GE ->
        "GE"
    | GOAL ->
        "GOAL"
    | GT ->
        "GT"
    | HAT ->
        "HAT"
    | ID _ ->
        "ID"
    | IF ->
        "IF"
    | IN ->
        "IN"
    | INT ->
        "INT"
    | INTEGER _ ->
        "INTEGER"
    | LE ->
        "LE"
    | LEFTARROW ->
        "LEFTARROW"
    | LEFTBR ->
        "LEFTBR"
    | LEFTPAR ->
        "LEFTPAR"
    | LEFTSQ ->
        "LEFTSQ"
    | LET ->
        "LET"
    | LOGIC ->
        "LOGIC"
    | LRARROW ->
        "LRARROW"
    | LT ->
        "LT"
    | MAPS_TO ->
        "MAPS_TO"
    | MATCH ->
        "MATCH"
    | MINUS ->
        "MINUS"
    | NOT ->
        "NOT"
    | NOTEQ ->
        "NOTEQ"
    | NUM _ ->
        "NUM"
    | OF ->
        "OF"
    | OR ->
        "OR"
    | PERCENT ->
        "PERCENT"
    | PLUS ->
        "PLUS"
    | POW ->
        "POW"
    | POWDOT ->
        "POWDOT"
    | PRED ->
        "PRED"
    | PROP ->
        "PROP"
    | PV ->
        "PV"
    | QM ->
        "QM"
    | QM_ID _ ->
        "QM_ID"
    | QUOTE ->
        "QUOTE"
    | REAL ->
        "REAL"
    | REWRITING ->
        "REWRITING"
    | RIGHTARROW ->
        "RIGHTARROW"
    | RIGHTBR ->
        "RIGHTBR"
    | RIGHTPAR ->
        "RIGHTPAR"
    | RIGHTSQ ->
        "RIGHTSQ"
    | SHARP ->
        "SHARP"
    | SLASH ->
        "SLASH"
    | STRING _ ->
        "STRING"
    | THEN ->
        "THEN"
    | THEORY ->
        "THEORY"
    | TIMES ->
        "TIMES"
    | TRUE ->
        "TRUE"
    | TYPE ->
        "TYPE"
    | UNIT ->
        "UNIT"
    | VOID ->
        "VOID"
    | WITH ->
        "WITH"
    | XOR ->
        "XOR"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37-39"]
  
  let rec _menhir_run_343 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _v ->
      let decls = _v in
      let _v = _menhir_action_030 decls in
      MenhirBox_file_parser _v
  
  let rec _menhir_goto_list1_decl : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState346 ->
          _menhir_run_347 _menhir_stack _v
      | MenhirState000 ->
          _menhir_run_343 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_347 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_decl -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _v ->
      let MenhirCell1_decl (_menhir_stack, _menhir_s, decl) = _menhir_stack in
      let decls = _v in
      let _v = _menhir_action_085 decl decls in
      _menhir_goto_list1_decl _menhir_stack _v _menhir_s
  
  let rec _menhir_run_206_spec_352 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_trigger_parser =
    fun _menhir_stack _v _tok ->
      let _v =
        let terms = _v in
        _menhir_action_159 terms
      in
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let trigger = _v in
          let _v = _menhir_action_160 trigger in
          MenhirBox_trigger_parser _v
      | _ ->
          _eRR ()
  
  let rec _menhir_run_001 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_TYPE (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | QUOTE ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState001
      | LEFTPAR ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState001
      | ID _ ->
          let _v = _menhir_action_164 () in
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState001 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_002 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let (_startpos__1_, _endpos_alpha_, alpha) = (_startpos, _endpos, _v) in
          let _v = _menhir_action_163 alpha in
          _menhir_goto_type_var _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_alpha_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_type_var : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState001 ->
          _menhir_run_055_spec_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState043 ->
          _menhir_run_055_spec_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState334 ->
          _menhir_run_031_spec_334 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState322 ->
          _menhir_run_031_spec_322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState316 ->
          _menhir_run_031_spec_316 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState303 ->
          _menhir_run_031_spec_303 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState185 ->
          _menhir_run_031_spec_185 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState101 ->
          _menhir_run_031_spec_101 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState021 ->
          _menhir_run_031_spec_021 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState033 ->
          _menhir_run_031_spec_033 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState024 ->
          _menhir_run_031_spec_024 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState007 ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState005 ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_055_spec_001 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_TYPE -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let alpha = _v in
      let _v = _menhir_action_165 alpha in
      _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState001 _tok
  
  and _menhir_run_011 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_TYPE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v_1 =
            let id = _v_0 in
            _menhir_action_035 id
          in
          (match (_tok : MenhirBasics.token) with
          | EQUAL ->
              let _menhir_stack = MenhirCell1_type_vars (_menhir_stack, _menhir_s, _v) in
              let _menhir_stack = MenhirCell1_ident (_menhir_stack, MenhirState011, _v_1, _startpos, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LEFTBR ->
                  _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState013
              | ID _v_2 ->
                  let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos_4, _startpos_3, _v_2) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState013 _tok
              | _ ->
                  _eRR ())
          | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
              let MenhirCell1_TYPE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
              let (_endpos_ty_, ty, ty_vars) = (_endpos, _v_1, _v) in
              let _v = _menhir_action_020 _endpos_ty_ _startpos__1_ ty ty_vars in
              _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_014 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LEFTBR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_0, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState014 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_020 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNIT ->
              let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_0 in
              let _v = _menhir_action_127 () in
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState021 _tok
          | REAL ->
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_2 in
              let _v = _menhir_action_126 () in
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState021 _tok
          | QUOTE ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState021
          | LEFTPAR ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState021
          | INT ->
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_4 in
              let _v = _menhir_action_124 () in
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState021 _tok
          | ID _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _v_9 =
                let id = _v_6 in
                _menhir_action_035 id
              in
              let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty) = (_endpos_8, _startpos_7, _v_9) in
              let _v = _menhir_action_129 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty in
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v MenhirState021 _tok
          | BOOL ->
              let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_11 in
              let _v = _menhir_action_125 () in
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState021 _tok
          | BITV ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState021
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_040 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          let _menhir_stack = MenhirCell1_primitive_type (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_1, _startpos, _v_0) in
          let _v = _menhir_action_035 id in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _tok
      | PV | RIGHTBR ->
          let MenhirCell1_ident (_menhir_stack, _menhir_s, id, _, _) = _menhir_stack in
          let ty = _v in
          let _v = _menhir_action_036 id ty in
          (match (_tok : MenhirBasics.token) with
          | PV ->
              let _menhir_stack = MenhirCell1_label_with_type (_menhir_stack, _menhir_s, _v) in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | ID _v_0 ->
                  let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos_1, _startpos, _v_0) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState018 _tok
              | _ ->
                  _eRR ())
          | RIGHTBR ->
              let label_typed = _v in
              let _v = _menhir_action_088 label_typed in
              _menhir_goto_list1_label_sep_PV _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _menhir_fail ())
      | _ ->
          _eRR ()
  
  and _menhir_run_036 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_primitive_type -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let MenhirCell1_primitive_type (_menhir_stack, _menhir_s, par, _) = _menhir_stack in
      let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_131 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty par in
      _menhir_goto_primitive_type _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v _menhir_s _tok
  
  and _menhir_goto_primitive_type : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState334 ->
          _menhir_run_335 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState322 ->
          _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState316 ->
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState303 ->
          _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState185 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState101 ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState021 ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState033 ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState024 ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_335 : type  ttv_stack. ((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_FUNC, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR, _menhir_box_file_parser) _menhir_cell1_list0_logic_binder_sep_comma _menhir_cell0_RIGHTPAR as 'stack) -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_primitive_type (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_1, _startpos, _v_0) in
          let _v = _menhir_action_035 id in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _tok
      | EQUAL ->
          let _menhir_stack = MenhirCell1_EQUAL (_menhir_stack, MenhirState335) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_3, _startpos) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState336 _tok
          | TRUE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState336 _tok
          | STRING _v_7 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState336
          | NUM _v_8 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_9, _startpos, _v_8) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState336 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | INTEGER _v_11 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_12, _startpos, _v_11) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState336 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | ID _v_14 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_15, _startpos, _v_14) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState336 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | FALSE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_17, _startpos) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState336 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_114 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SHARP ->
          let _menhir_stack = MenhirCell1_simple_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | QM_ID _v_0 ->
          let _menhir_stack = MenhirCell1_simple_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
      | QM ->
          let _menhir_stack = MenhirCell1_simple_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LEFTSQ ->
          let _menhir_stack = MenhirCell1_simple_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_simple_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_183 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COLON ->
          let _menhir_stack = MenhirCell1_simple_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_185 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AT | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | HAT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PERCENT | PLUS | POW | POWDOT | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | SLASH | THEN | THEORY | TIMES | TYPE | WITH | XOR ->
          let (_endpos_se_, _startpos_se_, se) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_039 se in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se_ _startpos_se_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_115 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_simple_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let MenhirCell1_simple_expr (_menhir_stack, _menhir_s, se, _startpos_se_, _) = _menhir_stack in
          let (_endpos_label_, label) = (_endpos, _v) in
          let _v = _menhir_action_150 _endpos_label_ _startpos_se_ label se in
          _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_label_ _startpos_se_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_simple_expr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState352 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState348 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState341 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState336 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState327 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState310 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState308 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState294 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState291 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState283 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState070 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState275 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState269 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState072 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState251 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState075 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState081 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState239 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState237 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState091 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState234 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState105 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState228 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState208 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState204 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState201 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState197 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState109 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState192 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState111 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState112 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState180 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState175 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState172 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState170 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState168 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState166 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState164 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState162 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState160 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState158 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState156 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState154 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState152 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState150 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState148 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState146 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState144 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState142 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState140 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState138 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState133 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState122 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState120 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState113 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState082 ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_085 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LEFTBR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_simple_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WITH ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_0 ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_2, _startpos_1, _v_0) in
              let _v = _menhir_action_035 id in
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState086 _tok
          | _ ->
              _eRR ())
      | SHARP ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | QM_ID _v_4 ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4
      | QM ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LEFTSQ ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_183 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COLON ->
          _menhir_run_185 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_089 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_090 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ident -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState090 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState090 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState090
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState090 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState090 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState090 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState090 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState090
      | _ ->
          _eRR ()
  
  and _menhir_run_067 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_STRING (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState068 _tok
          | TRUE ->
              let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_2) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState068 _tok
          | STRING _v_4 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState068
          | NUM _v_5 ->
              let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_6, _v_5) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState068 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | INTEGER _v_8 ->
              let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_9, _v_8) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState068 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | ID _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_12, _v_11) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState068 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | FALSE ->
              let _startpos_14 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_14) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState068 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState068
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_070 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState070 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState070 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState070
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState070 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState070 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState070 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState070 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | _ ->
          _eRR ()
  
  and _menhir_run_071 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_MINUS (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState071 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState071 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState071
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState071 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState071 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState071 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState071 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | _ ->
          _eRR ()
  
  and _menhir_run_072 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_MATCH (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState072 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState072 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState072
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState072 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState072 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState072 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState072 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState072
      | _ ->
          _eRR ()
  
  and _menhir_run_073 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LET (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_0, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_250 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState073 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_250 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_1, _startpos_0) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState251 _tok
          | TRUE ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_4, _startpos_3) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState251 _tok
          | STRING _v_6 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState251
          | NUM _v_7 ->
              let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_9, _startpos_8, _v_7) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState251 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | INTEGER _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_13, _startpos_12, _v_11) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState251 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | ID _v_15 ->
              let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_17, _startpos_16, _v_15) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState251 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | FALSE ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_20, _startpos_19) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState251 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState251
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_076 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | BAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | INTEGER _v ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | BAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | RIGHTSQ ->
                      let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      let (_startpos__1_, _endpos__5_, bv_cst) = (_startpos, _endpos_2, _v) in
                      let _v = _menhir_action_060 _endpos__5_ _startpos__1_ bv_cst in
                      _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_lexpr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState348 ->
          _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState341 ->
          _menhir_run_342 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState336 ->
          _menhir_run_337 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState327 ->
          _menhir_run_328 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState310 ->
          _menhir_run_311 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState308 ->
          _menhir_run_309 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState294 ->
          _menhir_run_293 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState291 ->
          _menhir_run_293 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState283 ->
          _menhir_run_284 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_279 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState070 ->
          _menhir_run_278 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState071 ->
          _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState275 ->
          _menhir_run_276 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState269 ->
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState072 ->
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState251 ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState075 ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState081 ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState239 ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState237 ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState091 ->
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState234 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState228 ->
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState352 ->
          _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState105 ->
          _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState204 ->
          _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState208 ->
          _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState201 ->
          _menhir_run_202 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState109 ->
          _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState192 ->
          _menhir_run_194 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState111 ->
          _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState112 ->
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState113 ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState180 ->
          _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState175 ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState170 ->
          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState168 ->
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState166 ->
          _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState164 ->
          _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState162 ->
          _menhir_run_163 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState160 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState158 ->
          _menhir_run_159 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState156 ->
          _menhir_run_157 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState154 ->
          _menhir_run_155 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState152 ->
          _menhir_run_153 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState150 ->
          _menhir_run_151 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState148 ->
          _menhir_run_149 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState146 ->
          _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState144 ->
          _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState142 ->
          _menhir_run_143 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState140 ->
          _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState138 ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState197 ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState172 ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState133 ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState122 ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState120 ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_350 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_lexpr_parser) _menhir_state -> _ -> _menhir_box_lexpr_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EOF ->
          let e = _v in
          let _v = _menhir_action_075 e in
          MenhirBox_lexpr_parser _v
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_122 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState122 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState122 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState122
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState122 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState122 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState122 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState122 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState122
      | _ ->
          _eRR ()
  
  and _menhir_run_081 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LEFTPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState081 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState081 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState081
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState081 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState081 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState081 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState081 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
      | _ ->
          _eRR ()
  
  and _menhir_run_082 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LEFTBR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState082 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState082 _tok
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState082 _tok
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState082
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState082
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState082 _tok
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          (match (_tok : MenhirBasics.token) with
          | LEFTPAR ->
              let _menhir_stack = MenhirCell1_ident (_menhir_stack, MenhirState082, _v, _startpos_4, _endpos) in
              _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
          | EQUAL ->
              let _menhir_stack = MenhirCell1_ident (_menhir_stack, MenhirState082, _v, _startpos_4, _endpos) in
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer
          | COLON | DOT | LEFTSQ | QM | QM_ID _ | SHARP | WITH ->
              let _v =
                let (_endpos_var_, _startpos_var_, var) = (_endpos, _startpos_4, _v) in
                _menhir_action_139 _endpos_var_ _startpos_var_ var
              in
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos_4 _v MenhirState082 _tok
          | _ ->
              _eRR ())
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState082 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_133 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ident -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell0_LEFTPAR (_menhir_stack, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState133 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState133 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState133
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState133 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState133 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState133 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState133 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState133
      | RIGHTPAR ->
          let _v = _menhir_action_076 () in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_091 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_IF (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState091 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState091 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState091
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState091 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState091 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState091 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState091 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState091
      | _ ->
          _eRR ()
  
  and _menhir_run_132 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LEFTPAR ->
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AT | AXIOM | BAR | CASESPLIT | COLON | COMMA | DOT | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | HAT | IN | LE | LEFTARROW | LEFTSQ | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PERCENT | PLUS | POW | POWDOT | PRED | PV | QM | QM_ID _ | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | SHARP | SLASH | THEN | THEORY | TIMES | TYPE | WITH | XOR ->
          let (_endpos_var_, _startpos_var_, var) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_139 _endpos_var_ _startpos_var_ var in
          _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_var_ _startpos_var_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_092 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_FORALL (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState092
      | _ ->
          _eRR ()
  
  and _menhir_run_093 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRING _v_0 ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (id, str) = (_v, _v_0) in
          let _v = _menhir_action_123 id str in
          _menhir_goto_named_ident _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | COLON | COMMA | EQUAL | LEFTPAR ->
          let id = _v in
          let _v = _menhir_action_122 id in
          _menhir_goto_named_ident _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_named_ident : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState329 ->
          _menhir_run_330 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState296 ->
          _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState314 ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState106 ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState099 ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState096 ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_330 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_FUNC as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_named_ident (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LEFTPAR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LEFTPAR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_0 ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_1, _v_0) in
              let _v = _menhir_action_035 id in
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState331 _tok
          | RIGHTPAR ->
              let _v = _menhir_action_078 () in
              _menhir_run_332 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState331
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_302 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNIT ->
              let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_0 in
              let _v = _menhir_action_127 () in
              _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState303 _tok
          | REAL ->
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_2 in
              let _v = _menhir_action_126 () in
              _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState303 _tok
          | QUOTE ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState303
          | LEFTPAR ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState303
          | INT ->
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_4 in
              let _v = _menhir_action_124 () in
              _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState303 _tok
          | ID _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _v_9 =
                let id = _v_6 in
                _menhir_action_035 id
              in
              let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty) = (_endpos_8, _startpos_7, _v_9) in
              let _v = _menhir_action_129 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty in
              _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v MenhirState303 _tok
          | BOOL ->
              let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_11 in
              let _v = _menhir_action_125 () in
              _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState303 _tok
          | BITV ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState303
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_304 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          let _menhir_stack = MenhirCell1_primitive_type (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_1, _startpos, _v_0) in
          let _v = _menhir_action_035 id in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _tok
      | COMMA | RIGHTPAR ->
          let MenhirCell1_ident (_menhir_stack, _menhir_s, id, _startpos_id_, _endpos_id_) = _menhir_stack in
          let ty = _v in
          let _v = _menhir_action_116 _endpos_id_ _startpos_id_ id ty in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_stack = MenhirCell1_logic_binder (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | ID _v_0 ->
                  let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_0) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState300 _tok
              | _ ->
                  _eRR ())
          | RIGHTPAR ->
              let binder = _v in
              let _v = _menhir_action_097 binder in
              _menhir_goto_list1_logic_binder_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _menhir_fail ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_logic_binder_sep_comma : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState331 ->
          _menhir_run_305_spec_331 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState298 ->
          _menhir_run_305_spec_298 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState300 ->
          _menhir_run_301 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_305_spec_331 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_FUNC, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let binders_l = _v in
      let _v = _menhir_action_079 binders_l in
      _menhir_run_332 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState331
  
  and _menhir_run_332 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_FUNC, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_list0_logic_binder_sep_comma (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RIGHTPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNIT ->
              let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_0 in
              let _v = _menhir_action_127 () in
              _menhir_run_335 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState334 _tok
          | REAL ->
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_2 in
              let _v = _menhir_action_126 () in
              _menhir_run_335 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState334 _tok
          | QUOTE ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState334
          | LEFTPAR ->
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState334
          | INT ->
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_4 in
              let _v = _menhir_action_124 () in
              _menhir_run_335 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState334 _tok
          | ID _v_6 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _v_8 =
                let id = _v_6 in
                _menhir_action_035 id
              in
              let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty) = (_endpos_7, _startpos, _v_8) in
              let _v = _menhir_action_129 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty in
              _menhir_run_335 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v MenhirState334 _tok
          | BOOL ->
              let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_10 in
              let _v = _menhir_action_125 () in
              _menhir_run_335 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState334 _tok
          | BITV ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState334
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_024 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LEFTPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UNIT ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_127 () in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState024 _tok
      | REAL ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_126 () in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState024 _tok
      | QUOTE ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState024
      | LEFTPAR ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState024
      | INT ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_124 () in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState024 _tok
      | ID _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty) = (_endpos, _startpos_0, _v) in
          let _v = _menhir_action_129 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v MenhirState024 _tok
      | BOOL ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_125 () in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState024 _tok
      | BITV ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState024
      | _ ->
          _eRR ()
  
  and _menhir_run_032 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          let _menhir_stack = MenhirCell1_primitive_type (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_1, _startpos, _v_0) in
          let _v = _menhir_action_035 id in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _tok
      | COMMA ->
          let _menhir_stack = MenhirCell1_primitive_type (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState032
      | RIGHTARROW | RIGHTPAR ->
          let ty = _v in
          let _v = _menhir_action_106 ty in
          _menhir_goto_list1_primitive_type_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_033 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_primitive_type as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UNIT ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_127 () in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState033 _tok
      | REAL ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_126 () in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState033 _tok
      | QUOTE ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState033
      | LEFTPAR ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState033
      | INT ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_124 () in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState033 _tok
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_129 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v MenhirState033 _tok
      | BOOL ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_125 () in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState033 _tok
      | BITV ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState033
      | _ ->
          _eRR ()
  
  and _menhir_run_027 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LEFTSQ ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | INTEGER _v ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RIGHTSQ ->
                  let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__4_, sz) = (_endpos_2, _v) in
                  let _v = _menhir_action_128 sz in
                  _menhir_goto_primitive_type _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_primitive_type_sep_comma : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState316 ->
          _menhir_run_320_spec_316 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState024 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState033 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_320_spec_316 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let ty_l = _v in
      let _v = _menhir_action_081 ty_l in
      _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState316 _tok
  
  and _menhir_run_321 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RIGHTARROW ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNIT ->
              let _menhir_stack = MenhirCell1_list0_primitive_type_sep_comma (_menhir_stack, _menhir_s, _v) in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos in
              let _v = _menhir_action_127 () in
              _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState322 _tok
          | REAL ->
              let _menhir_stack = MenhirCell1_list0_primitive_type_sep_comma (_menhir_stack, _menhir_s, _v) in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos in
              let _v = _menhir_action_126 () in
              _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState322 _tok
          | QUOTE ->
              let _menhir_stack = MenhirCell1_list0_primitive_type_sep_comma (_menhir_stack, _menhir_s, _v) in
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState322
          | PROP ->
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__3_, ty_list) = (_endpos, _v) in
              let _v = _menhir_action_117 ty_list in
              _menhir_goto_logic_type _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _tok
          | LEFTPAR ->
              let _menhir_stack = MenhirCell1_list0_primitive_type_sep_comma (_menhir_stack, _menhir_s, _v) in
              _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState322
          | INT ->
              let _menhir_stack = MenhirCell1_list0_primitive_type_sep_comma (_menhir_stack, _menhir_s, _v) in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos in
              let _v = _menhir_action_124 () in
              _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState322 _tok
          | ID _v_3 ->
              let _menhir_stack = MenhirCell1_list0_primitive_type_sep_comma (_menhir_stack, _menhir_s, _v) in
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _v_4 =
                let id = _v_3 in
                _menhir_action_035 id
              in
              let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty) = (_endpos, _startpos, _v_4) in
              let _v = _menhir_action_129 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty in
              _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v MenhirState322 _tok
          | BOOL ->
              let _menhir_stack = MenhirCell1_list0_primitive_type_sep_comma (_menhir_stack, _menhir_s, _v) in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos in
              let _v = _menhir_action_125 () in
              _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState322 _tok
          | BITV ->
              let _menhir_stack = MenhirCell1_list0_primitive_type_sep_comma (_menhir_stack, _menhir_s, _v) in
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState322
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_324 : type  ttv_stack. ((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma, _menhir_box_file_parser) _menhir_cell1_list0_primitive_type_sep_comma as 'stack) -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          let _menhir_stack = MenhirCell1_primitive_type (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_1, _startpos, _v_0) in
          let _v = _menhir_action_035 id in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _tok
      | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let MenhirCell1_list0_primitive_type_sep_comma (_menhir_stack, _, ty_list) = _menhir_stack in
          let (_endpos_ret_ty_, ret_ty) = (_endpos, _v) in
          let _v = _menhir_action_119 ret_ty ty_list in
          _menhir_goto_logic_type _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ret_ty_ _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_logic_type : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
  
  and _menhir_run_319 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_list1_named_ident_sep_comma (_menhir_stack, _, ids) = _menhir_stack in
      let MenhirCell0_ac_modifier (_menhir_stack, is_ac) = _menhir_stack in
      let MenhirCell1_LOGIC (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos_ty_, ty) = (_endpos, _v) in
      let _v = _menhir_action_023 _endpos_ty_ _startpos__1_ ids is_ac ty in
      _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_decl : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TYPE ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v) in
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState346
      | THEORY ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v) in
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState346
      | REWRITING ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v) in
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState346
      | PRED ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v) in
          _menhir_run_296 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState346
      | LOGIC ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v) in
          _menhir_run_312 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState346
      | GOAL ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v) in
          _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState346
      | FUNC ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v) in
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState346
      | AXIOM ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v) in
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState346
      | EOF ->
          let decl = _v in
          let _v = _menhir_action_084 decl in
          _menhir_goto_list1_decl _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_057 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_THEORY (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, MenhirState057, _v, _startpos_0, _endpos) in
          (match (_tok : MenhirBasics.token) with
          | EXTENDS ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | ID _v_1 ->
                  let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos_3, _startpos_2, _v_1) in
                  let _v = _menhir_action_035 id in
                  let (_endpos, _startpos, _menhir_s) = (_endpos_id_, _startpos_id_, MenhirState059) in
                  let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
                  (match (_tok : MenhirBasics.token) with
                  | EQUAL ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | CASESPLIT ->
                          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState061
                      | AXIOM ->
                          _menhir_run_281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState061
                      | END ->
                          let _v = _menhir_action_157 () in
                          _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer _v
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_062 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_CASESPLIT (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, MenhirState062, _v, _startpos_0, _endpos) in
          (match (_tok : MenhirBasics.token) with
          | COLON ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOID ->
                  let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_2, _startpos_1) in
                  let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState064 _tok
              | TRUE ->
                  let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos_4) in
                  let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState064 _tok
              | STRING _v_7 ->
                  _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState064
              | NUM _v_8 ->
                  let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos_10, _startpos_9, _v_8) in
                  let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState064 _tok
              | NOT ->
                  _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | MINUS ->
                  _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | MATCH ->
                  _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | LET ->
                  _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | LEFTSQ ->
                  _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | LEFTPAR ->
                  _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | LEFTBR ->
                  _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | INTEGER _v_12 ->
                  let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos_14, _startpos_13, _v_12) in
                  let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState064 _tok
              | IF ->
                  _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | ID _v_16 ->
                  let _startpos_17 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos_18, _startpos_17, _v_16) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState064 _tok
              | FORALL ->
                  _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | FALSE ->
                  let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_21, _startpos_20) in
                  let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState064 _tok
              | EXISTS ->
                  _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | DISTINCT ->
                  _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | CUT ->
                  _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | CHECK ->
                  _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_106 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_EXISTS (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState106
      | _ ->
          _eRR ()
  
  and _menhir_run_110 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_DISTINCT (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LEFTPAR ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LEFTPAR (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState111 _tok
          | TRUE ->
              let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_2) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState111 _tok
          | STRING _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState111
          | NUM _v ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState111 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | INTEGER _v ->
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_4, _v) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState111 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | ID _v ->
              let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_5, _v) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState111 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | FALSE ->
              let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_6) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState111 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_112 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_CUT (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState112 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState112 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState112
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState112 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState112 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState112 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState112 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState112
      | _ ->
          _eRR ()
  
  and _menhir_run_113 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_CHECK (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState113 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState113 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState113
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState113 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState113 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState113 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState113 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
      | _ ->
          _eRR ()
  
  and _menhir_run_281 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_AXIOM (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, MenhirState281, _v, _startpos_0, _endpos) in
          (match (_tok : MenhirBasics.token) with
          | COLON ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOID ->
                  let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_2, _startpos_1) in
                  let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState283 _tok
              | TRUE ->
                  let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos_4) in
                  let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState283 _tok
              | STRING _v_7 ->
                  _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState283
              | NUM _v_8 ->
                  let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos_10, _startpos_9, _v_8) in
                  let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState283 _tok
              | NOT ->
                  _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | MINUS ->
                  _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | MATCH ->
                  _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | LET ->
                  _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | LEFTSQ ->
                  _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | LEFTPAR ->
                  _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | LEFTBR ->
                  _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | INTEGER _v_12 ->
                  let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos_14, _startpos_13, _v_12) in
                  let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState283 _tok
              | IF ->
                  _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | ID _v_16 ->
                  let _startpos_17 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos_18, _startpos_17, _v_16) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState283 _tok
              | FORALL ->
                  _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | FALSE ->
                  let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_21, _startpos_20) in
                  let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState283 _tok
              | EXISTS ->
                  _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | DISTINCT ->
                  _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | CUT ->
                  _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | CHECK ->
                  _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState283
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_285 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_THEORY, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_ident -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_ident (_menhir_stack, _, th_ext, _, _) = _menhir_stack in
      let MenhirCell1_ident (_menhir_stack, _, th_id, _, _) = _menhir_stack in
      let MenhirCell1_THEORY (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos__7_, th_body) = (_endpos, _v) in
      let _v = _menhir_action_019 _endpos__7_ _startpos__1_ th_body th_ext th_id in
      _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_289 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_REWRITING (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, MenhirState289, _v, _startpos_0, _endpos) in
          (match (_tok : MenhirBasics.token) with
          | COLON ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOID ->
                  let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_2, _startpos_1) in
                  let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
              | TRUE ->
                  let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos_4) in
                  let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
              | STRING _v_7 ->
                  _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState291
              | NUM _v_8 ->
                  let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos_10, _startpos_9, _v_8) in
                  let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState291 _tok
              | NOT ->
                  _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | MINUS ->
                  _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | MATCH ->
                  _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | LET ->
                  _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | LEFTSQ ->
                  _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | LEFTPAR ->
                  _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | LEFTBR ->
                  _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | INTEGER _v_12 ->
                  let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos_14, _startpos_13, _v_12) in
                  let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState291 _tok
              | IF ->
                  _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | ID _v_16 ->
                  let _startpos_17 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos_18, _startpos_17, _v_16) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState291 _tok
              | FORALL ->
                  _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | FALSE ->
                  let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_21, _startpos_20) in
                  let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
              | EXISTS ->
                  _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | DISTINCT ->
                  _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | CUT ->
                  _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | CHECK ->
                  _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_296 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_PRED (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState296
      | _ ->
          _eRR ()
  
  and _menhir_run_312 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LOGIC (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | AC ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_004 () in
          _menhir_goto_ac_modifier _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | ID _ ->
          let _v = _menhir_action_003 () in
          _menhir_goto_ac_modifier _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_ac_modifier : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_LOGIC -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _menhir_stack = MenhirCell0_ac_modifier (_menhir_stack, _v) in
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState314
      | _ ->
          _eRR ()
  
  and _menhir_run_325 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_GOAL (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, MenhirState325, _v, _startpos_0, _endpos) in
          (match (_tok : MenhirBasics.token) with
          | COLON ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOID ->
                  let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_2, _startpos_1) in
                  let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState327 _tok
              | TRUE ->
                  let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos_4) in
                  let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState327 _tok
              | STRING _v_7 ->
                  _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState327
              | NUM _v_8 ->
                  let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos_10, _startpos_9, _v_8) in
                  let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState327 _tok
              | NOT ->
                  _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | MINUS ->
                  _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | MATCH ->
                  _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | LET ->
                  _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | LEFTSQ ->
                  _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | LEFTPAR ->
                  _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | LEFTBR ->
                  _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | INTEGER _v_12 ->
                  let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos_14, _startpos_13, _v_12) in
                  let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState327 _tok
              | IF ->
                  _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | ID _v_16 ->
                  let _startpos_17 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos_18, _startpos_17, _v_16) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState327 _tok
              | FORALL ->
                  _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | FALSE ->
                  let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_21, _startpos_20) in
                  let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState327 _tok
              | EXISTS ->
                  _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | DISTINCT ->
                  _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | CUT ->
                  _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | CHECK ->
                  _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState327
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_329 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_FUNC (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState329
      | _ ->
          _eRR ()
  
  and _menhir_run_339 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_AXIOM (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, MenhirState339, _v, _startpos_0, _endpos) in
          (match (_tok : MenhirBasics.token) with
          | COLON ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOID ->
                  let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_2, _startpos_1) in
                  let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState341 _tok
              | TRUE ->
                  let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos_4) in
                  let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState341 _tok
              | STRING _v_7 ->
                  _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState341
              | NUM _v_8 ->
                  let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos_10, _startpos_9, _v_8) in
                  let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState341 _tok
              | NOT ->
                  _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | MINUS ->
                  _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | MATCH ->
                  _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | LET ->
                  _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | LEFTSQ ->
                  _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | LEFTPAR ->
                  _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | LEFTBR ->
                  _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | INTEGER _v_12 ->
                  let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos_14, _startpos_13, _v_12) in
                  let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState341 _tok
              | IF ->
                  _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | ID _v_16 ->
                  let _startpos_17 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos_18, _startpos_17, _v_16) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState341 _tok
              | FORALL ->
                  _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | FALSE ->
                  let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_21, _startpos_20) in
                  let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState341 _tok
              | EXISTS ->
                  _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | DISTINCT ->
                  _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | CUT ->
                  _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | CHECK ->
                  _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_037 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LEFTPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RIGHTPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_0 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _v_2 =
                let id = _v_0 in
                _menhir_action_035 id
              in
              let MenhirCell1_LEFTPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
              let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty, pars) = (_endpos_1, _startpos, _v_2, _v) in
              let _v = _menhir_action_132 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty pars in
              _menhir_goto_primitive_type _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_034 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_primitive_type, ttv_result) _menhir_cell1_COMMA -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_primitive_type (_menhir_stack, _menhir_s, ty, _) = _menhir_stack in
      let ty_l = _v in
      let _v = _menhir_action_107 ty ty_l in
      _menhir_goto_list1_primitive_type_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_305_spec_298 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_PRED, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let binders_l = _v in
      let _v = _menhir_action_079 binders_l in
      _menhir_run_306 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState298
  
  and _menhir_run_306 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_PRED, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_list0_logic_binder_sep_comma (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RIGHTPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_0, _startpos) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState308 _tok
          | TRUE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_2, _startpos) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState308 _tok
          | STRING _v_4 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState308
          | NUM _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_6, _startpos, _v_5) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState308 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | INTEGER _v_8 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_9, _startpos, _v_8) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState308 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | ID _v_11 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_12, _startpos, _v_11) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState308 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | FALSE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_14, _startpos) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState308 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState308
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_301 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_logic_binder -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_logic_binder (_menhir_stack, _menhir_s, binder) = _menhir_stack in
      let binders_list = _v in
      let _v = _menhir_action_098 binder binders_list in
      _menhir_goto_list1_logic_binder_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_297 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_PRED as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_named_ident (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LEFTPAR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LEFTPAR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_0 ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_1, _v_0) in
              let _v = _menhir_action_035 id in
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState298 _tok
          | RIGHTPAR ->
              let _v = _menhir_action_078 () in
              _menhir_run_306 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState298
          | _ ->
              _eRR ())
      | EQUAL ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState310 _tok
          | TRUE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState310 _tok
          | STRING _v_6 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState310
          | NUM _v_7 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_7) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState310 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | INTEGER _v_9 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_9) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState310 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | ID _v_11 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_11) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState310 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | FALSE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState310 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState310
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_095 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_named_ident (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v ->
              _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState096
          | _ ->
              _eRR ())
      | COLON ->
          let id = _v in
          let _v = _menhir_action_104 id in
          _menhir_goto_list1_named_ident_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_named_ident_sep_comma : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState314 ->
          _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState106 ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState092 ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState099 ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState096 ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_315 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_list1_named_ident_sep_comma (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UNIT ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_127 () in
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState316 _tok
      | REAL ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_126 () in
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState316 _tok
      | QUOTE ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | PROP ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_118 () in
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _tok
      | LEFTPAR ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | INT ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_124 () in
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState316 _tok
      | ID _v_4 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v_5 =
            let id = _v_4 in
            _menhir_action_035 id
          in
          let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty) = (_endpos, _startpos, _v_5) in
          let _v = _menhir_action_129 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty in
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v MenhirState316 _tok
      | BOOL ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_125 () in
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState316 _tok
      | BITV ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | RIGHTARROW ->
          let _v = _menhir_action_080 () in
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState316 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_318 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma as 'stack) -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          let _menhir_stack = MenhirCell1_primitive_type (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_1, _startpos, _v_0) in
          let _v = _menhir_action_035 id in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _tok
      | COMMA ->
          let _menhir_stack = MenhirCell1_primitive_type (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
      | RIGHTARROW ->
          let ty = _v in
          let _v = _menhir_action_106 ty in
          _menhir_goto_list1_primitive_type_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let (_endpos_ret_ty_, ret_ty) = (_endpos, _v) in
          let _v = _menhir_action_120 ret_ty in
          _menhir_goto_logic_type _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ret_ty_ _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_100 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_list1_named_ident_sep_comma (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UNIT ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_127 () in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState101 _tok
      | REAL ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_126 () in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState101 _tok
      | QUOTE ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState101
      | LEFTPAR ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState101
      | INT ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_124 () in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState101 _tok
      | ID _v_3 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v_4 =
            let id = _v_3 in
            _menhir_action_035 id
          in
          let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty) = (_endpos, _startpos, _v_4) in
          let _v = _menhir_action_129 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v MenhirState101 _tok
      | BOOL ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_125 () in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState101 _tok
      | BITV ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState101
      | _ ->
          _eRR ()
  
  and _menhir_run_102 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_list1_named_ident_sep_comma as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          let _menhir_stack = MenhirCell1_primitive_type (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_1, _startpos, _v_0) in
          let _v = _menhir_action_035 id in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _tok
      | COMMA | DOT | LEFTBR | LEFTSQ ->
          let MenhirCell1_list1_named_ident_sep_comma (_menhir_stack, _menhir_s, binders) = _menhir_stack in
          let ty = _v in
          let _v = _menhir_action_121 binders ty in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_stack = MenhirCell1_multi_logic_binder (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | ID _v ->
                  _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState099
              | _ ->
                  _eRR ())
          | DOT | LEFTBR | LEFTSQ ->
              let binders = _v in
              let _v = _menhir_action_102 binders in
              _menhir_goto_list1_multi_logic_binder _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _menhir_fail ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_multi_logic_binder : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState106 ->
          _menhir_run_107 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState092 ->
          _menhir_run_104 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState099 ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_107 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXISTS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_list1_multi_logic_binder (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LEFTSQ ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
      | DOT | LEFTBR ->
          let _v = _menhir_action_161 () in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState107 _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_105 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_list1_multi_logic_binder as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_LEFTSQ (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_1, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState105 _tok
      | TRUE ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_3, _startpos_2) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState105 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState105
      | NUM _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState105 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | INTEGER _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState105 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | ID _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_9, _startpos_8, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState105 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | FALSE ->
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_11, _startpos_10) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState105 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
      | _ ->
          _eRR ()
  
  and _menhir_run_227 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | MAPS_TO ->
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_1, _startpos_0) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
          | TRUE ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_4, _startpos_3) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
          | STRING _v_6 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState228
          | NUM _v_7 ->
              let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_9, _startpos_8, _v_7) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState228 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | INTEGER _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_13, _startpos_12, _v_11) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState228 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | ID _v_15 ->
              let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_17, _startpos_16, _v_15) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState228 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | FALSE ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_20, _startpos_19) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
          | _ ->
              _eRR ())
      | LEFTPAR ->
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AT | BAR | COLON | COMMA | DOT | EOF | EQUAL | GE | GT | HAT | IN | LE | LEFTSQ | LRARROW | LT | MINUS | NOTEQ | OR | PERCENT | PLUS | POW | POWDOT | QM | QM_ID _ | RIGHTARROW | RIGHTSQ | SHARP | SLASH | TIMES | XOR ->
          let (_endpos_var_, _startpos_var_, var) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_139 _endpos_var_ _startpos_var_ var in
          _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_var_ _startpos_var_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_108 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_EXISTS, ttv_result) _menhir_cell1_list1_multi_logic_binder as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_triggers (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LEFTBR ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState108
      | DOT ->
          let _v = _menhir_action_032 () in
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState108 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_109 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_triggers as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LEFTBR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState109 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState109 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState109
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState109 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState109 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState109 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState109 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState109
      | _ ->
          _eRR ()
  
  and _menhir_run_200 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_EXISTS, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_triggers as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_filters (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState201 _tok
          | TRUE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState201 _tok
          | STRING _v_2 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState201
          | NUM _v_3 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_3) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState201 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | INTEGER _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_5) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState201 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | ID _v_7 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_7) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState201 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | FALSE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState201 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState201
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_104 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FORALL as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_list1_multi_logic_binder (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LEFTSQ ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState104
      | DOT | LEFTBR ->
          let _v = _menhir_action_161 () in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState104 _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_232 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FORALL, ttv_result) _menhir_cell1_list1_multi_logic_binder as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_triggers (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LEFTBR ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | DOT ->
          let _v = _menhir_action_032 () in
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState232 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_233 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_FORALL, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_triggers as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_filters (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
          | TRUE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
          | STRING _v_2 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState234
          | NUM _v_3 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_3) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState234 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | INTEGER _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_5) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState234 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | ID _v_7 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_7) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState234 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | FALSE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_103 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_multi_logic_binder -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_multi_logic_binder (_menhir_stack, _menhir_s, binders) = _menhir_stack in
      let l = _v in
      let _v = _menhir_action_103 binders l in
      _menhir_goto_list1_multi_logic_binder _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_097 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_named_ident -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_named_ident (_menhir_stack, _menhir_s, id) = _menhir_stack in
      let l = _v in
      let _v = _menhir_action_105 id l in
      _menhir_goto_list1_named_ident_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_135 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ident _menhir_cell0_LEFTPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RIGHTPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LEFTPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ident (_menhir_stack, _menhir_s, app, _startpos_app_, _) = _menhir_stack in
          let (args, _endpos__4_) = (_v, _endpos) in
          let _v = _menhir_action_143 _endpos__4_ _startpos_app_ app args in
          _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos_app_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_124 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState124 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState124 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState124
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState124 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState124 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState124 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState124 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
      | _ ->
          _eRR ()
  
  and _menhir_run_138 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState138 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState138 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState138
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState138 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState138 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState138 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState138 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState138
      | _ ->
          _eRR ()
  
  and _menhir_run_140 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState140 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState140 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState140
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState140 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState140 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState140 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState140 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState140
      | _ ->
          _eRR ()
  
  and _menhir_run_142 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState142 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState142 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState142
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState142 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState142 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState142 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState142 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState142
      | _ ->
          _eRR ()
  
  and _menhir_run_144 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState144 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState144 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState144
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState144 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState144 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState144 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState144 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState144
      | _ ->
          _eRR ()
  
  and _menhir_run_146 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState146 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState146 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState146
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState146 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState146 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState146 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState146 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState146
      | _ ->
          _eRR ()
  
  and _menhir_run_148 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState148 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState148 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState148
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState148 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState148 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState148 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState148 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState148
      | _ ->
          _eRR ()
  
  and _menhir_run_152 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState152 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState152 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState152
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState152 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState152 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState152 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState152 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState152
      | _ ->
          _eRR ()
  
  and _menhir_run_154 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState154 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState154 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState154
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState154 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState154 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState154 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState154 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState154
      | _ ->
          _eRR ()
  
  and _menhir_run_156 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell0_MINUS (_menhir_stack, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState156 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState156 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState156
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState156 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState156 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState156 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState156 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState156
      | _ ->
          _eRR ()
  
  and _menhir_run_158 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState158 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState158 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState158
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState158 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState158 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState158 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState158 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState158
      | _ ->
          _eRR ()
  
  and _menhir_run_170 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState170 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState170 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState170
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState170 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState170 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState170 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState170 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState170
      | _ ->
          _eRR ()
  
  and _menhir_run_160 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState160 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState160 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState160
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState160 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState160 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState160 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState160 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState160
      | _ ->
          _eRR ()
  
  and _menhir_run_126 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LEFTBR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | INTEGER _v ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COMMA ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | INTEGER _v_1 ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | RIGHTBR ->
                          let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, e, _startpos_e_, _) = _menhir_stack in
                          let (i, _endpos__7_, j) = (_v, _endpos_4, _v_1) in
                          let _v = _menhir_action_061 _endpos__7_ _startpos_e_ e i j in
                          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos_e_ _v _menhir_s _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_162 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState162 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState162 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState162
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState162 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState162 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState162 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState162 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState162
      | _ ->
          _eRR ()
  
  and _menhir_run_164 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState164 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState164 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState164
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState164 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState164 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState164 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState164 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState164
      | _ ->
          _eRR ()
  
  and _menhir_run_166 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState166 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState166 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState166
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState166 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState166 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState166 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState166 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
      | _ ->
          _eRR ()
  
  and _menhir_run_150 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState150 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState150 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState150
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState150 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState150 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState150 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState150 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState150
      | _ ->
          _eRR ()
  
  and _menhir_run_168 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell0_AND (_menhir_stack, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState168 _tok
      | TRUE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState168 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState168
      | NUM _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState168 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | INTEGER _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState168 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | ID _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState168 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | FALSE ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_5) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState168 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState168
      | _ ->
          _eRR ()
  
  and _menhir_run_342 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_AXIOM, _menhir_box_file_parser) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let MenhirCell1_ident (_menhir_stack, _, name, _, _) = _menhir_stack in
          let MenhirCell1_AXIOM (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_body_, body) = (_endpos, _v) in
          let _v = _menhir_action_027 _endpos_body_ _startpos__1_ body name in
          _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_337 : type  ttv_stack. ((((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_FUNC, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR, _menhir_box_file_parser) _menhir_cell1_list0_logic_binder_sep_comma _menhir_cell0_RIGHTPAR, _menhir_box_file_parser) _menhir_cell1_primitive_type, _menhir_box_file_parser) _menhir_cell1_EQUAL as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let MenhirCell1_EQUAL (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_primitive_type (_menhir_stack, _, ret_ty, _) = _menhir_stack in
          let MenhirCell0_RIGHTPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_list0_logic_binder_sep_comma (_menhir_stack, _, args) = _menhir_stack in
          let MenhirCell0_LEFTPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_named_ident (_menhir_stack, _, app) = _menhir_stack in
          let MenhirCell1_FUNC (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_body_, body) = (_endpos, _v) in
          let _v = _menhir_action_024 _endpos_body_ _startpos__1_ app args body ret_ty in
          _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_328 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_GOAL, _menhir_box_file_parser) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let MenhirCell1_ident (_menhir_stack, _, name, _, _) = _menhir_stack in
          let MenhirCell1_GOAL (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_body_, body) = (_endpos, _v) in
          let _v = _menhir_action_029 _endpos_body_ _startpos__1_ body name in
          _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_311 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_PRED, _menhir_box_file_parser) _menhir_cell1_named_ident as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let MenhirCell1_named_ident (_menhir_stack, _, app) = _menhir_stack in
          let MenhirCell1_PRED (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_body_, body) = (_endpos, _v) in
          let _v = _menhir_action_025 _endpos_body_ _startpos__1_ app body in
          _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_309 : type  ttv_stack. ((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_PRED, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR, _menhir_box_file_parser) _menhir_cell1_list0_logic_binder_sep_comma _menhir_cell0_RIGHTPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let MenhirCell0_RIGHTPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_list0_logic_binder_sep_comma (_menhir_stack, _, args) = _menhir_stack in
          let MenhirCell0_LEFTPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_named_ident (_menhir_stack, _, app) = _menhir_stack in
          let MenhirCell1_PRED (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_body_, body) = (_endpos, _v) in
          let _v = _menhir_action_026 _endpos_body_ _startpos__1_ app args body in
          _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_293 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PV ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_2, _startpos_1) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState294 _tok
          | TRUE ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos_4) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState294 _tok
          | STRING _v_7 ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState294
          | NUM _v_8 ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_10, _startpos_9, _v_8) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState294 _tok
          | NOT ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | MINUS ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | MATCH ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | LET ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | LEFTSQ ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | LEFTPAR ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | LEFTBR ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | INTEGER _v_12 ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_14, _startpos_13, _v_12) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState294 _tok
          | IF ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | ID _v_16 ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              let _startpos_17 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_18, _startpos_17, _v_16) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState294 _tok
          | FORALL ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | FALSE ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_21, _startpos_20) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState294 _tok
          | EXISTS ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | DISTINCT ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | CUT ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | CHECK ->
              let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState294
          | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
              let (_endpos__2_, e) = (_endpos_0, _v) in
              let _v = _menhir_action_095 e in
              _menhir_goto_list1_lexpr_sep_pv _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _v _menhir_s _tok
          | _ ->
              _eRR ())
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let (_endpos_e_, e) = (_endpos, _v) in
          let _v = _menhir_action_094 e in
          _menhir_goto_list1_lexpr_sep_pv _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_e_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_lexpr_sep_pv : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState294 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState291 ->
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_295 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_lexpr _menhir_cell0_PV -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell0_PV (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _menhir_s, e, _, _) = _menhir_stack in
      let (_endpos_e_l_, e_l) = (_endpos, _v) in
      let _v = _menhir_action_096 e e_l in
      _menhir_goto_list1_lexpr_sep_pv _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_e_l_ _v _menhir_s _tok
  
  and _menhir_run_292 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_REWRITING, _menhir_box_file_parser) _menhir_cell1_ident -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_ident (_menhir_stack, _, name, _, _) = _menhir_stack in
      let MenhirCell1_REWRITING (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos_body_, body) = (_endpos, _v) in
      let _v = _menhir_action_028 _endpos_body_ _startpos__1_ body name in
      _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_284 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_AXIOM, _menhir_box_file_parser) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | CASESPLIT | END ->
          let MenhirCell1_ident (_menhir_stack, _, name, _, _) = _menhir_stack in
          let MenhirCell1_AXIOM (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_body_, body) = (_endpos, _v) in
          let _v = _menhir_action_155 _endpos_body_ _startpos__1_ body name in
          _menhir_goto_theory_elt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_theory_elt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_theory_elt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | CASESPLIT ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState287
      | AXIOM ->
          _menhir_run_281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState287
      | END ->
          let _v = _menhir_action_157 () in
          _menhir_run_288 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_288 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_theory_elt -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_theory_elt (_menhir_stack, _menhir_s, th_elt) = _menhir_stack in
      let th_rest = _v in
      let _v = _menhir_action_158 th_elt th_rest in
      _menhir_goto_theory_elts _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_theory_elts : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState287 ->
          _menhir_run_288 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState061 ->
          _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_280 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_CASESPLIT, _menhir_box_file_parser) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | CASESPLIT | END ->
          let MenhirCell1_ident (_menhir_stack, _, name, _, _) = _menhir_stack in
          let MenhirCell1_CASESPLIT (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_body_, body) = (_endpos, _v) in
          let _v = _menhir_action_156 _endpos_body_ _startpos__1_ body name in
          _menhir_goto_theory_elt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_279 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_STRING -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_STRING (_menhir_stack, _menhir_s, name, _startpos_name_) = _menhir_stack in
      let (_endpos_e_, e) = (_endpos, _v) in
      let _v = _menhir_action_067 _endpos_e_ _startpos_name_ e name in
      _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_e_ _startpos_name_ _v _menhir_s _tok
  
  and _menhir_run_278 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NOT -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos_se_, se) = (_endpos, _v) in
      let _v = _menhir_action_058 _endpos_se_ _startpos__1_ se in
      _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_277 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_MINUS -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_MINUS (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos_se_, se) = (_endpos, _v) in
      let _v = _menhir_action_059 _endpos_se_ _startpos__1_ se in
      _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_276 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_MATCH, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_list1_match_cases, ttv_result) _menhir_cell1_simple_pattern as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | BAR | END ->
          let MenhirCell1_simple_pattern (_menhir_stack, _, p) = _menhir_stack in
          let MenhirCell1_list1_match_cases (_menhir_stack, _menhir_s, l) = _menhir_stack in
          let e = _v in
          let _v = _menhir_action_101 e l p in
          _menhir_goto_list1_match_cases _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_match_cases : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_MATCH, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_lexpr (_menhir_stack, _, e, _, _) = _menhir_stack in
          let MenhirCell1_MATCH (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__5_, cases) = (_endpos, _v) in
          let _v = _menhir_action_071 _endpos__5_ _startpos__1_ cases e in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | BAR ->
          let _menhir_stack = MenhirCell1_list1_match_cases (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_0 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_0) in
              let _v = _menhir_action_035 id in
              _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState273 _tok
          | _ ->
              _eRR ())
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_261 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LEFTPAR ->
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LEFTPAR (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_1 ->
              let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_3, _startpos_2, _v_1) in
              let _v = _menhir_action_035 id in
              _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState262 _tok
          | _ ->
              _eRR ())
      | RIGHTARROW ->
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_151 _endpos_id_ _startpos_id_ id in
          _menhir_goto_simple_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_265 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_0 ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_2, _startpos_1, _v_0) in
              let _v = _menhir_action_035 id in
              _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState266 _tok
          | _ ->
              _eRR ())
      | RIGHTPAR ->
          let id = _v in
          let _v = _menhir_action_108 id in
          _menhir_goto_list1_string_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_string_sep_comma : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState266 ->
          _menhir_run_267 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState262 ->
          _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_267 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ident -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_ident (_menhir_stack, _menhir_s, id, _, _) = _menhir_stack in
      let l = _v in
      let _v = _menhir_action_109 id l in
      _menhir_goto_list1_string_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_263 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ident _menhir_cell0_LEFTPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LEFTPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ident (_menhir_stack, _menhir_s, app, _startpos_app_, _) = _menhir_stack in
      let (args, _endpos__4_) = (_v, _endpos) in
      let _v = _menhir_action_152 _endpos__4_ _startpos_app_ app args in
      _menhir_goto_simple_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_simple_pattern : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState273 ->
          _menhir_run_274 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState256 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState257 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_274 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_MATCH, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_list1_match_cases as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_simple_pattern (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RIGHTARROW ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState275 _tok
          | TRUE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState275 _tok
          | STRING _v_2 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState275
          | NUM _v_3 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_3) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState275 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | INTEGER _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_5) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState275 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | ID _v_7 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_7) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState275 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | FALSE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState275 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_268 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_MATCH, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_simple_pattern (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RIGHTARROW ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState269 _tok
          | TRUE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState269 _tok
          | STRING _v_2 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState269
          | NUM _v_3 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_3) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState269 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | INTEGER _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_5) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState269 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | ID _v_7 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_7) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState269 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | FALSE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState269 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_258 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_MATCH, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_BAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_simple_pattern (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RIGHTARROW ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState259 _tok
          | TRUE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState259 _tok
          | STRING _v_2 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState259
          | NUM _v_3 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_3) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState259 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | INTEGER _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_5) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState259 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | ID _v_7 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_7) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState259 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | FALSE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState259 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_270 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_MATCH, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_simple_pattern as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | BAR | END ->
          let MenhirCell1_simple_pattern (_menhir_stack, _menhir_s, p) = _menhir_stack in
          let e = _v in
          let _v = _menhir_action_099 e p in
          _menhir_goto_list1_match_cases _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_260 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_MATCH, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_BAR, ttv_result) _menhir_cell1_simple_pattern as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | BAR | END ->
          let MenhirCell1_simple_pattern (_menhir_stack, _, p) = _menhir_stack in
          let MenhirCell1_BAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let e = _v in
          let _v = _menhir_action_100 e p in
          _menhir_goto_list1_match_cases _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_255 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MATCH as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | WITH ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_0 ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_2, _startpos_1, _v_0) in
              let _v = _menhir_action_035 id in
              _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState256 _tok
          | BAR ->
              let _menhir_stack = MenhirCell1_BAR (_menhir_stack, MenhirState256) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | ID _v_4 ->
                  let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos_6, _startpos_5, _v_4) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState257 _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | TIMES ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_252 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_0 ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_2, _startpos_1, _v_0) in
              let _v = _menhir_action_035 id in
              _menhir_run_250 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState253 _tok
          | _ ->
              _eRR ())
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | IN ->
          let MenhirCell1_ident (_menhir_stack, _menhir_s, binder, _, _) = _menhir_stack in
          let e = _v in
          let _v = _menhir_action_037 binder e in
          _menhir_goto_let_binders _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_let_binders : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState253 ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState073 ->
          _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_254 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ident, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_lexpr (_menhir_stack, _, e, _, _) = _menhir_stack in
      let MenhirCell1_ident (_menhir_stack, _menhir_s, binder, _, _) = _menhir_stack in
      let l = _v in
      let _v = _menhir_action_038 binder e l in
      _menhir_goto_let_binders _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_074 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LET as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_let_binders (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState075 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState075 _tok
      | STRING _v_2 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState075
      | NUM _v_3 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_3) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState075 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | INTEGER _v_5 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_5) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState075 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | ID _v_7 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_7) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState075 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState075 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState075
      | _ ->
          _eRR ()
  
  and _menhir_run_249 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LET, ttv_result) _menhir_cell1_let_binders as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | FUNC | GOAL | IN | LEFTARROW | LOGIC | PRED | PV | REWRITING | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH ->
          let MenhirCell1_let_binders (_menhir_stack, _, binders) = _menhir_stack in
          let MenhirCell1_LET (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_e2_, e2) = (_endpos, _v) in
          let _v = _menhir_action_068 _endpos_e2_ _startpos__1_ binders e2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_e2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_247 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LEFTPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LEFTPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__3_, e) = (_endpos_0, _v) in
          let _v = _menhir_action_146 e in
          _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_241 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PV ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_PV (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_1 ->
              let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_3, _startpos_2, _v_1) in
              let _v = _menhir_action_035 id in
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState242 _tok
          | _ ->
              _eRR ())
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTBR ->
          let MenhirCell1_ident (_menhir_stack, _menhir_s, id, _, _) = _menhir_stack in
          let e = _v in
          let _v = _menhir_action_086 e id in
          _menhir_goto_list1_label_expr_sep_PV _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_label_expr_sep_PV : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState082 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState242 ->
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState086 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_244 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LEFTBR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LEFTBR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos__3_, labels) = (_endpos, _v) in
      let _v = _menhir_action_140 _endpos__3_ _startpos__1_ labels in
      _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_243 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ident, ttv_result) _menhir_cell1_lexpr _menhir_cell0_PV -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell0_PV (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _, e, _, _) = _menhir_stack in
      let MenhirCell1_ident (_menhir_stack, _menhir_s, id, _, _) = _menhir_stack in
      let l = _v in
      let _v = _menhir_action_087 e id l in
      _menhir_goto_list1_label_expr_sep_PV _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_087 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LEFTBR, ttv_result) _menhir_cell1_simple_expr -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_simple_expr (_menhir_stack, _, se, _, _) = _menhir_stack in
      let MenhirCell1_LEFTBR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos__5_, labels) = (_endpos, _v) in
      let _v = _menhir_action_141 _endpos__5_ _startpos__1_ labels se in
      _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_240 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | FUNC | GOAL | IN | LEFTARROW | LOGIC | LRARROW | OR | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _, br1, _, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _, cond, _, _) = _menhir_stack in
          let MenhirCell1_IF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_br2_, br2) = (_endpos, _v) in
          let _v = _menhir_action_064 _endpos_br2_ _startpos__1_ br1 br2 cond in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_br2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_238 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ELSE ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_1, _startpos_0) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState239 _tok
          | TRUE ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_4, _startpos_3) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState239 _tok
          | STRING _v_6 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState239
          | NUM _v_7 ->
              let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_9, _startpos_8, _v_7) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState239 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | INTEGER _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_13, _startpos_12, _v_11) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState239 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | ID _v_15 ->
              let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_17, _startpos_16, _v_15) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState239 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | FALSE ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_20, _startpos_19) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState239 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
          | _ ->
              _eRR ())
      | AT ->
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_236 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_IF as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | THEN ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_1, _startpos_0) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState237 _tok
          | TRUE ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_4, _startpos_3) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState237 _tok
          | STRING _v_6 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState237
          | NUM _v_7 ->
              let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_9, _startpos_8, _v_7) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState237 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | INTEGER _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_13, _startpos_12, _v_11) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState237 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | ID _v_15 ->
              let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_17, _startpos_16, _v_15) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState237 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | FALSE ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_20, _startpos_19) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState237 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
          | _ ->
              _eRR ())
      | SLASH ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_235 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_FORALL, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_triggers, ttv_result) _menhir_cell1_filters as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | FUNC | GOAL | IN | LEFTARROW | LOGIC | PRED | PV | REWRITING | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH ->
          let MenhirCell1_filters (_menhir_stack, _, filters) = _menhir_stack in
          let MenhirCell1_triggers (_menhir_stack, _, triggers) = _menhir_stack in
          let MenhirCell1_list1_multi_logic_binder (_menhir_stack, _, quant_vars) = _menhir_stack in
          let MenhirCell1_FORALL (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_body_, body) = (_endpos, _v) in
          let _v = _menhir_action_065 _endpos_body_ _startpos__1_ body filters quant_vars triggers in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_body_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_229 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | BAR | COMMA | EOF | RIGHTSQ ->
          let MenhirCell1_ident (_menhir_stack, _menhir_s, id, _startpos_id_, _) = _menhir_stack in
          let (_endpos_e_, e) = (_endpos, _v) in
          let _v = _menhir_action_074 _endpos_e_ _startpos_id_ e id in
          _menhir_goto_lexpr_or_dom _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_lexpr_or_dom : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_lexpr_or_dom (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState208 _tok
          | TRUE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState208 _tok
          | STRING _v_2 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState208
          | NUM _v_3 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_3) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState208 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | INTEGER _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_5) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState208 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | ID _v_7 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_7) in
              let _v = _menhir_action_035 id in
              _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState208 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | FALSE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState208 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | _ ->
              _eRR ())
      | BAR | EOF | RIGHTSQ ->
          let ed = _v in
          let _v = _menhir_action_090 ed in
          _menhir_goto_list1_lexpr_or_dom_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_lexpr_or_dom_sep_comma : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState208 ->
          _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState352 ->
          _menhir_run_206_spec_352 _menhir_stack _v _tok
      | MenhirState105 ->
          _menhir_run_206_spec_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState204 ->
          _menhir_run_206_spec_204 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_209 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr_or_dom -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_lexpr_or_dom (_menhir_stack, _menhir_s, ed) = _menhir_stack in
      let edl = _v in
      let _v = _menhir_action_091 ed edl in
      _menhir_goto_list1_lexpr_or_dom_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_206_spec_105 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_LEFTSQ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let terms = _v in
      let _v = _menhir_action_159 terms in
      _menhir_run_203 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState105 _tok
  
  and _menhir_run_203 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | BAR ->
          let _menhir_stack = MenhirCell1_trigger (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState204 _tok
          | TRUE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState204 _tok
          | STRING _v_2 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState204
          | NUM _v_3 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_3) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState204 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | INTEGER _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_5) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState204 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | ID _v_7 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_7) in
              let _v = _menhir_action_035 id in
              _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState204 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | FALSE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState204 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState204
          | _ ->
              _eRR ())
      | RIGHTSQ ->
          let trig = _v in
          let _v = _menhir_action_110 trig in
          _menhir_goto_list1_trigger_sep_bar _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_trigger_sep_bar : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState105 ->
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState204 ->
          _menhir_run_205 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_230 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_LEFTSQ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LEFTSQ (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      let trigs = _v in
      let _v = _menhir_action_162 trigs in
      _menhir_goto_triggers _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_triggers : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_list1_multi_logic_binder as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState104 ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState107 ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_205 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_trigger -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_trigger (_menhir_stack, _menhir_s, trig) = _menhir_stack in
      let trigs = _v in
      let _v = _menhir_action_111 trig trigs in
      _menhir_goto_list1_trigger_sep_bar _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_206_spec_204 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_trigger -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let terms = _v in
      let _v = _menhir_action_159 terms in
      _menhir_run_203 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState204 _tok
  
  and _menhir_run_210 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RIGHTSQ ->
              let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_0 in
              let _v = _menhir_action_154 () in
              _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState211 _tok
          | LEFTSQ ->
              let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _endpos__1_ = _endpos_3 in
              let _v = _menhir_action_153 () in
              _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState211 _tok
          | _ ->
              _eRR ())
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | BAR | COMMA | EOF | RIGHTSQ ->
          let e = _v in
          let _v = _menhir_action_072 e in
          _menhir_goto_lexpr_or_dom _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_214 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_sq (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | QM_ID _v_0 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_1, _startpos, _v_0) in
          let _v = _menhir_action_013 _endpos_id_ _startpos_id_ id in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState214 _tok
      | QM ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_3, _startpos) in
          let _v = _menhir_action_012 _endpos__1_ _startpos__1_ in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState214 _tok
      | NUM _v_5 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos_6, _startpos, _v_5) in
          let _v = _menhir_action_016 _endpos_i_ _startpos_i_ i in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState214 _tok
      | MINUS ->
          _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState214
      | INTEGER _v_8 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos_9, _startpos, _v_8) in
          let _v = _menhir_action_015 _endpos_i_ _startpos_i_ i in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState214 _tok
      | ID _v_11 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_12, _startpos, _v_11) in
          let _v = _menhir_action_014 _endpos_id_ _startpos_id_ id in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState214 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_223 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_sq as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_bound (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | QM_ID _v_0 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_0) in
              let _v = _menhir_action_013 _endpos_id_ _startpos_id_ id in
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState224 _tok
          | QM ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_012 _endpos__1_ _startpos__1_ in
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState224 _tok
          | NUM _v_3 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_3) in
              let _v = _menhir_action_016 _endpos_i_ _startpos_i_ i in
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState224 _tok
          | MINUS ->
              _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | INTEGER _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_5) in
              let _v = _menhir_action_015 _endpos_i_ _startpos_i_ i in
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState224 _tok
          | ID _v_7 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_7) in
              let _v = _menhir_action_014 _endpos_id_ _startpos_id_ id in
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState224 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_225 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_sq, ttv_result) _menhir_cell1_bound as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_bound (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RIGHTSQ ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_154 () in
          _menhir_run_226 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _tok
      | LEFTSQ ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_153 () in
          _menhir_run_226 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_226 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_sq, ttv_result) _menhir_cell1_bound, ttv_result) _menhir_cell1_bound -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_bound (_menhir_stack, _, rbnd) = _menhir_stack in
      let MenhirCell1_bound (_menhir_stack, _, lbnd) = _menhir_stack in
      let MenhirCell1_sq (_menhir_stack, _, lbr, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _menhir_s, e, _startpos_e_, _) = _menhir_stack in
      let (_endpos_rbr_, rbr) = (_endpos, _v) in
      let _v = _menhir_action_073 _endpos_rbr_ _startpos_e_ e lbnd lbr rbnd rbr in
      _menhir_goto_lexpr_or_dom _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_218 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NUM _v ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _endpos_i_, i) = (_startpos, _endpos, _v) in
          let _v = _menhir_action_018 _endpos_i_ _startpos__1_ i in
          _menhir_goto_bound _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | INTEGER _v ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _endpos_i_, i) = (_startpos, _endpos, _v) in
          let _v = _menhir_action_017 _endpos_i_ _startpos__1_ i in
          _menhir_goto_bound _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_bound : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState224 ->
          _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState214 ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_202 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_EXISTS, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_triggers, ttv_result) _menhir_cell1_filters as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | FUNC | GOAL | IN | LEFTARROW | LOGIC | PRED | PV | REWRITING | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH ->
          let MenhirCell1_filters (_menhir_stack, _, filters) = _menhir_stack in
          let MenhirCell1_triggers (_menhir_stack, _, triggers) = _menhir_stack in
          let MenhirCell1_list1_multi_logic_binder (_menhir_stack, _, quant_vars) = _menhir_stack in
          let MenhirCell1_EXISTS (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos_body_, body) = (_endpos, _v) in
          let _v = _menhir_action_066 _endpos_body_ _startpos__1_ body filters quant_vars triggers in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_body_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_195 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_triggers, ttv_result) _menhir_cell1_LEFTBR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTBR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LEFTBR (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let filt = _v in
          let _v = _menhir_action_033 filt in
          _menhir_goto_filters _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_2, _startpos_1) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState197 _tok
          | TRUE ->
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos_4) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState197 _tok
          | STRING _v_7 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState197
          | NUM _v_8 ->
              let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_10, _startpos_9, _v_8) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState197 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | INTEGER _v_12 ->
              let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_14, _startpos_13, _v_12) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState197 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | ID _v_16 ->
              let _startpos_17 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_18, _startpos_17, _v_16) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState197 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | FALSE ->
              let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_21, _startpos_20) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState197 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState197
          | RIGHTBR ->
              let _v = _menhir_action_076 () in
              _menhir_run_198 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_goto_filters : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_triggers as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState232 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState108 ->
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_198 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_triggers, ttv_result) _menhir_cell1_LEFTBR, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RIGHTBR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_lexpr (_menhir_stack, _, filt, _, _) = _menhir_stack in
          let MenhirCell1_LEFTBR (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let filt_l = _v in
          let _v = _menhir_action_034 filt filt_l in
          _menhir_goto_filters _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_194 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTPAR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, e1, _, _) = _menhir_stack in
          let e2 = _v in
          let _v = _menhir_action_114 e1 e2 in
          _menhir_goto_list2_lexpr_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_192 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState192 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState192 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState192
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState192 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState192 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState192 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState192 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState192
      | _ ->
          _eRR ()
  
  and _menhir_goto_list2_lexpr_sep_comma : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState192 ->
          _menhir_run_193 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState111 ->
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_193 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_lexpr (_menhir_stack, _menhir_s, e, _, _) = _menhir_stack in
      let el = _v in
      let _v = _menhir_action_115 e el in
      _menhir_goto_list2_lexpr_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_189 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DISTINCT _menhir_cell0_LEFTPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LEFTPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_DISTINCT (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos__4_, dist_l) = (_endpos, _v) in
      let _v = _menhir_action_063 _endpos__4_ _startpos__1_ dist_l in
      _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_191 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DISTINCT _menhir_cell0_LEFTPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_188 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_CUT -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_CUT (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos_e_, e) = (_endpos, _v) in
      let _v = _menhir_action_070 _endpos_e_ _startpos__1_ e in
      _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_e_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_187 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_CHECK -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_CHECK (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos_e_, e) = (_endpos, _v) in
      let _v = _menhir_action_069 _endpos_e_ _startpos__1_ e in
      _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_e_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_181 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_array_assignement as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LEFTARROW ->
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_175 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState175 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState175 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState175
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState175 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState175 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState175 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState175 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState175
      | _ ->
          _eRR ()
  
  and _menhir_run_176 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RIGHTSQ ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, e1, _, _) = _menhir_stack in
          let e2 = _v in
          let _v = _menhir_action_009 e1 e2 in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_stack = MenhirCell1_array_assignement (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOID ->
                  let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
                  let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState180 _tok
              | TRUE ->
                  let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
                  let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState180 _tok
              | STRING _v_2 ->
                  _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState180
              | NUM _v_3 ->
                  let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_3) in
                  let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState180 _tok
              | NOT ->
                  _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | MINUS ->
                  _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | MATCH ->
                  _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | LET ->
                  _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | LEFTSQ ->
                  _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | LEFTPAR ->
                  _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | LEFTBR ->
                  _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | INTEGER _v_5 ->
                  let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v_5) in
                  let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState180 _tok
              | IF ->
                  _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | ID _v_7 ->
                  let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_7) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState180 _tok
              | FORALL ->
                  _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | FALSE ->
                  let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
                  let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
                  _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState180 _tok
              | EXISTS ->
                  _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | DISTINCT ->
                  _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | CUT ->
                  _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | CHECK ->
                  _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState180
              | _ ->
                  _eRR ())
          | RIGHTSQ ->
              let assign = _v in
              let _v = _menhir_action_010 assign in
              _menhir_goto_array_assignements _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _menhir_fail ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_array_assignements : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState180 ->
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState120 ->
          _menhir_run_177 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_182 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_array_assignement -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_array_assignement (_menhir_stack, _menhir_s, assign) = _menhir_stack in
      let assign_l = _v in
      let _v = _menhir_action_011 assign assign_l in
      _menhir_goto_array_assignements _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_177 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_simple_expr _menhir_cell0_LEFTSQ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LEFTSQ (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_simple_expr (_menhir_stack, _menhir_s, se, _startpos_se_, _) = _menhir_stack in
      let (_endpos__4_, assigns) = (_endpos, _v) in
      let _v = _menhir_action_145 _endpos__4_ _startpos_se_ assigns se in
      _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos_se_ _v _menhir_s _tok
  
  and _menhir_run_171 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | FUNC | GOAL | IN | LEFTARROW | LOGIC | PRED | PV | REWRITING | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_050 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_169 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr _menhir_cell0_AND as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | FUNC | GOAL | IN | LEFTARROW | LOGIC | LRARROW | OR | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell0_AND (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_047 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_167 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | NOTEQ | OR | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_056 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_165 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | NOTEQ | OR | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_055 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_163 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | NOTEQ | OR | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_054 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_161 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | NOTEQ | OR | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_053 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_159 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | NOTEQ | OR | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_052 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_157 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr _menhir_cell0_MINUS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PLUS | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell0_MINUS (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_041 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_155 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | NOTEQ | OR | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_057 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_153 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | FUNC | GOAL | IN | LEFTARROW | LOGIC | LRARROW | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_048 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_151 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AT | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PERCENT | PLUS | POW | POWDOT | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | SLASH | THEN | THEORY | TIMES | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, e1, _startpos_e1_, _) = _menhir_stack in
          let (_endpos_e2_, e2) = (_endpos, _v) in
          let _v = _menhir_action_062 _endpos_e2_ _startpos_e1_ e1 e2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_e2_ _startpos_e1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_149 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AT | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PERCENT | PLUS | POW | POWDOT | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | SLASH | THEN | THEORY | TIMES | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_044 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_147 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PLUS | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_040 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_145 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AT | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PERCENT | PLUS | POW | POWDOT | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | SLASH | THEN | THEORY | TIMES | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_045 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_143 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AT | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PERCENT | PLUS | POW | POWDOT | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | SLASH | THEN | THEORY | TIMES | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_046 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_141 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | FUNC | GOAL | IN | LEFTARROW | LOGIC | PRED | PV | REWRITING | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_051 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_139 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AT | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PERCENT | PLUS | POW | POWDOT | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | SLASH | THEN | THEORY | TIMES | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_043 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_137 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_1, _startpos_0) in
              let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState172 _tok
          | TRUE ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_4, _startpos_3) in
              let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState172 _tok
          | STRING _v_6 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState172
          | NUM _v_7 ->
              let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_9, _startpos_8, _v_7) in
              let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState172 _tok
          | NOT ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | MINUS ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | MATCH ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | LET ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | LEFTSQ ->
              _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | LEFTPAR ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | LEFTBR ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | INTEGER _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_i_, _startpos_i_, i) = (_endpos_13, _startpos_12, _v_11) in
              let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState172 _tok
          | IF ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | ID _v_15 ->
              let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos_17, _startpos_16, _v_15) in
              let _v = _menhir_action_035 id in
              _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState172 _tok
          | FORALL ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | FALSE ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_20, _startpos_19) in
              let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState172 _tok
          | EXISTS ->
              _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | DISTINCT ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | CUT ->
              _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | CHECK ->
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState172
          | _ ->
              _eRR ())
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTBR | RIGHTPAR ->
          let e = _v in
          let _v = _menhir_action_092 e in
          _menhir_goto_list1_lexpr_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_lexpr_sep_comma : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState172 ->
          _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState197 ->
          _menhir_run_134_spec_197 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState133 ->
          _menhir_run_134_spec_133 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_173 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_lexpr (_menhir_stack, _menhir_s, e, _, _) = _menhir_stack in
      let l = _v in
      let _v = _menhir_action_093 e l in
      _menhir_goto_list1_lexpr_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_134_spec_197 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_list1_multi_logic_binder, ttv_result) _menhir_cell1_triggers, ttv_result) _menhir_cell1_LEFTBR, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let l = _v in
      let _v = _menhir_action_077 l in
      _menhir_run_198 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_134_spec_133 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ident _menhir_cell0_LEFTPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let l = _v in
      let _v = _menhir_action_077 l in
      _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_125 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND | AT | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | IN | LE | LEFTARROW | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PERCENT | PLUS | POW | POWDOT | PRED | PV | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | SLASH | THEN | THEORY | TIMES | TYPE | WITH | XOR ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_042 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_123 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AXIOM | BAR | CASESPLIT | COMMA | ELSE | END | EOF | FUNC | GOAL | IN | LEFTARROW | LOGIC | PRED | PV | REWRITING | RIGHTBR | RIGHTPAR | RIGHTSQ | THEN | THEORY | TYPE | WITH ->
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, se1, _startpos_se1_, _) = _menhir_stack in
          let (_endpos_se2_, se2) = (_endpos, _v) in
          let _v = _menhir_action_049 _endpos_se2_ _startpos_se1_ se1 se2 in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_se2_ _startpos_se1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_121 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_simple_expr _menhir_cell0_LEFTSQ as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer
      | TIMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RIGHTSQ ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LEFTSQ (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_simple_expr (_menhir_stack, _menhir_s, se, _startpos_se_, _) = _menhir_stack in
          let (e, _endpos__4_) = (_v, _endpos_0) in
          let _v = _menhir_action_144 _endpos__4_ _startpos_se_ e se in
          _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos_se_ _v _menhir_s _tok
      | RIGHTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POWDOT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | POW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NOTEQ ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_158 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LRARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LEFTARROW ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_168 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_117 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_simple_expr -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_simple_expr (_menhir_stack, _menhir_s, se, _startpos_se_, _) = _menhir_stack in
      let (_endpos_id_, id) = (_endpos, _v) in
      let _v = _menhir_action_149 _endpos_id_ _startpos_se_ id se in
      _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_se_ _v _menhir_s _tok
  
  and _menhir_run_118 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_simple_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let MenhirCell1_simple_expr (_menhir_stack, _menhir_s, se, _startpos_se_, _) = _menhir_stack in
          let (_endpos_id_, id) = (_endpos_1, _v) in
          let _v = _menhir_action_148 _endpos_id_ _startpos_se_ id se in
          _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_se_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_120 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_simple_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_LEFTSQ (_menhir_stack, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_1, _startpos_0) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState120 _tok
      | TRUE ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_3, _startpos_2) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState120 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState120
      | NUM _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState120 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | INTEGER _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState120 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | ID _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_9, _startpos_8, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState120 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | FALSE ->
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_11, _startpos_10) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState120 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState120
      | _ ->
          _eRR ()
  
  and _menhir_run_183 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_simple_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ID _v ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let MenhirCell1_simple_expr (_menhir_stack, _menhir_s, se, _startpos_se_, _) = _menhir_stack in
          let (_endpos_label_, label) = (_endpos, _v) in
          let _v = _menhir_action_142 _endpos_label_ _startpos_se_ label se in
          _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_label_ _startpos_se_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_185 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_simple_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UNIT ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_127 () in
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState185 _tok
      | REAL ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_126 () in
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState185 _tok
      | QUOTE ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState185
      | LEFTPAR ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState185
      | INT ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_124 () in
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState185 _tok
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let id = _v in
            _menhir_action_035 id
          in
          let (_endpos_ext_ty_, _startpos_ext_ty_, ext_ty) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_129 _endpos_ext_ty_ _startpos_ext_ty_ ext_ty in
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ext_ty_ _v MenhirState185 _tok
      | BOOL ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos in
          let _v = _menhir_action_125 () in
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState185 _tok
      | BITV ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState185
      | _ ->
          _eRR ()
  
  and _menhir_run_186 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_simple_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          let _menhir_stack = MenhirCell1_primitive_type (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos_1, _startpos, _v_0) in
          let _v = _menhir_action_035 id in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _tok
      | AND | AT | AXIOM | BAR | CASESPLIT | COLON | COMMA | DOT | ELSE | END | EOF | EQUAL | FUNC | GE | GOAL | GT | HAT | IN | LE | LEFTARROW | LEFTSQ | LOGIC | LRARROW | LT | MINUS | NOTEQ | OR | PERCENT | PLUS | POW | POWDOT | PRED | PV | QM | QM_ID _ | REWRITING | RIGHTARROW | RIGHTBR | RIGHTPAR | RIGHTSQ | SHARP | SLASH | THEN | THEORY | TIMES | TYPE | WITH | XOR ->
          let MenhirCell1_simple_expr (_menhir_stack, _menhir_s, se, _startpos_se_, _) = _menhir_stack in
          let (_endpos_ty_, ty) = (_endpos, _v) in
          let _v = _menhir_action_147 _endpos_ty_ _startpos_se_ se ty in
          _menhir_goto_simple_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_ty_ _startpos_se_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_label_sep_PV : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState018 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState014 ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_019 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_label_with_type _menhir_cell0_PV -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell0_PV (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_label_with_type (_menhir_stack, _menhir_s, lt) = _menhir_stack in
      let list_lt = _v in
      let _v = _menhir_action_089 list_lt lt in
      _menhir_goto_list1_label_sep_PV _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_015 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_LEFTBR -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LEFTBR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let (_endpos__3_, labels) = (_endpos, _v) in
      let _v = _menhir_action_133 labels in
      _menhir_goto_record_type _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_goto_record_type : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState050 ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState013 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_051 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_ident -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let _2 = _v in
      let _v = _menhir_action_006 _2 in
      _menhir_goto_algebraic_args _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
  
  and _menhir_goto_algebraic_args : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_ident -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      match (_tok : MenhirBasics.token) with
      | BAR ->
          let _menhir_stack = MenhirCell0_algebraic_args (_menhir_stack, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ID _v_0 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v_0) in
              let _v = _menhir_action_035 id in
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState053 _tok
          | _ ->
              _eRR ())
      | AND | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let MenhirCell1_ident (_menhir_stack, _menhir_s, cons, _, _) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_082 _2 cons in
          _menhir_goto_list1_constructors_sep_bar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_049 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ident (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | OF ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LEFTBR ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | _ ->
              _eRR ())
      | AND | AXIOM | BAR | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let _v = _menhir_action_005 () in
          _menhir_goto_algebraic_args _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_constructors_sep_bar : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState053 ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState046 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState013 ->
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_054 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_ident _menhir_cell0_algebraic_args -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell0_algebraic_args (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_ident (_menhir_stack, _menhir_s, cons, _, _) = _menhir_stack in
      let cons_l = _v in
      let _v = _menhir_action_083 _2 cons cons_l in
      _menhir_goto_list1_constructors_sep_bar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
  
  and _menhir_run_047 : type  ttv_stack. (((((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar, _menhir_box_file_parser) _menhir_cell1_AND, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_list1_constructors_sep_bar (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | AND ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let _v = _menhir_action_007 () in
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_043 : type  ttv_stack. ((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar as 'stack) -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_AND (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | QUOTE ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | LEFTPAR ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | ID _ ->
          let _v = _menhir_action_164 () in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_005 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LEFTPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | QUOTE ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
      | _ ->
          _eRR ()
  
  and _menhir_run_044 : type  ttv_stack. (((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar, _menhir_box_file_parser) _menhir_cell1_AND as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_type_vars (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | ID _v_0 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v_1 =
            let id = _v_0 in
            _menhir_action_035 id
          in
          let _menhir_stack = MenhirCell1_ident (_menhir_stack, MenhirState044, _v_1, _startpos, _endpos) in
          (match (_tok : MenhirBasics.token) with
          | EQUAL ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | ID _v_2 ->
                  let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos_id_, _startpos_id_, id) = (_endpos_4, _startpos_3, _v_2) in
                  let _v = _menhir_action_035 id in
                  _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState046 _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_048 : type  ttv_stack. (((((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar, _menhir_box_file_parser) _menhir_cell1_AND, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_list1_constructors_sep_bar (_menhir_stack, _, enum) = _menhir_stack in
      let MenhirCell1_ident (_menhir_stack, _, ty, _, _) = _menhir_stack in
      let MenhirCell1_type_vars (_menhir_stack, _, ty_vars) = _menhir_stack in
      let MenhirCell1_AND (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos_others_, others) = (_endpos, _v) in
      let _v = _menhir_action_008 _endpos_others_ _startpos__1_ enum others ty ty_vars in
      _menhir_goto_and_recursive_opt _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_others_ _v _menhir_s _tok
  
  and _menhir_goto_and_recursive_opt : type  ttv_stack. ((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar as 'stack) -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState042 ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState047 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_056 : type  ttv_stack. ((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_TYPE, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_list1_constructors_sep_bar (_menhir_stack, _, enum) = _menhir_stack in
      let MenhirCell1_ident (_menhir_stack, _, ty, _, _) = _menhir_stack in
      let MenhirCell1_type_vars (_menhir_stack, _, ty_vars) = _menhir_stack in
      let MenhirCell1_TYPE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos_others_, others) = (_endpos, _v) in
      let _v = _menhir_action_021 _endpos_others_ _startpos__1_ enum others ty ty_vars in
      _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_042 : type  ttv_stack. ((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_TYPE, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident as 'stack) -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_list1_constructors_sep_bar (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | AND ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState042
      | AXIOM | EOF | FUNC | GOAL | LOGIC | PRED | REWRITING | THEORY | TYPE ->
          let _v = _menhir_action_007 () in
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_041 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_TYPE, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_ident (_menhir_stack, _, ty, _, _) = _menhir_stack in
      let MenhirCell1_type_vars (_menhir_stack, _, ty_vars) = _menhir_stack in
      let MenhirCell1_TYPE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos_record_, record) = (_endpos, _v) in
      let _v = _menhir_action_022 _endpos_record_ _startpos__1_ record ty ty_vars in
      _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_055_spec_043 : type  ttv_stack. ((((ttv_stack, _menhir_box_file_parser) _menhir_cell1_type_vars, _menhir_box_file_parser) _menhir_cell1_ident, _menhir_box_file_parser) _menhir_cell1_list1_constructors_sep_bar, _menhir_box_file_parser) _menhir_cell1_AND -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let alpha = _v in
      let _v = _menhir_action_165 alpha in
      _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043 _tok
  
  and _menhir_run_031_spec_334 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_FUNC, _menhir_box_file_parser) _menhir_cell1_named_ident _menhir_cell0_LEFTPAR, _menhir_box_file_parser) _menhir_cell1_list0_logic_binder_sep_comma _menhir_cell0_RIGHTPAR -> _ -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos_alpha_, _startpos_alpha_, alpha) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_130 _endpos_alpha_ _startpos_alpha_ alpha in
      _menhir_run_335 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_alpha_ _v MenhirState334 _tok
  
  and _menhir_run_031_spec_322 : type  ttv_stack. (((ttv_stack, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma, _menhir_box_file_parser) _menhir_cell1_list0_primitive_type_sep_comma -> _ -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos_alpha_, _startpos_alpha_, alpha) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_130 _endpos_alpha_ _startpos_alpha_ alpha in
      _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_alpha_ _v MenhirState322 _tok
  
  and _menhir_run_031_spec_316 : type  ttv_stack. ((ttv_stack, _menhir_box_file_parser) _menhir_cell1_LOGIC _menhir_cell0_ac_modifier, _menhir_box_file_parser) _menhir_cell1_list1_named_ident_sep_comma -> _ -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos_alpha_, _startpos_alpha_, alpha) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_130 _endpos_alpha_ _startpos_alpha_ alpha in
      _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_alpha_ _v MenhirState316 _tok
  
  and _menhir_run_031_spec_303 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_ident -> _ -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos_alpha_, _startpos_alpha_, alpha) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_130 _endpos_alpha_ _startpos_alpha_ alpha in
      _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_alpha_ _v MenhirState303 _tok
  
  and _menhir_run_031_spec_185 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_simple_expr -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos_alpha_, _startpos_alpha_, alpha) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_130 _endpos_alpha_ _startpos_alpha_ alpha in
      _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_alpha_ _v MenhirState185 _tok
  
  and _menhir_run_031_spec_101 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_list1_named_ident_sep_comma -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos_alpha_, _startpos_alpha_, alpha) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_130 _endpos_alpha_ _startpos_alpha_ alpha in
      _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_alpha_ _v MenhirState101 _tok
  
  and _menhir_run_031_spec_021 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_ident -> _ -> _ -> _ -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos_alpha_, _startpos_alpha_, alpha) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_130 _endpos_alpha_ _startpos_alpha_ alpha in
      _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_alpha_ _v MenhirState021 _tok
  
  and _menhir_run_031_spec_033 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_primitive_type, ttv_result) _menhir_cell1_COMMA -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos_alpha_, _startpos_alpha_, alpha) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_130 _endpos_alpha_ _startpos_alpha_ alpha in
      _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_alpha_ _v MenhirState033 _tok
  
  and _menhir_run_031_spec_024 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LEFTPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos_alpha_, _startpos_alpha_, alpha) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_130 _endpos_alpha_ _startpos_alpha_ alpha in
      _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_alpha_ _v MenhirState024 _tok
  
  and _menhir_run_006 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_type_var (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | QUOTE ->
              _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState007
          | _ ->
              _eRR ())
      | RIGHTPAR ->
          let alpha = _v in
          let _v = _menhir_action_112 alpha in
          _menhir_goto_list1_type_var_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_list1_type_var_sep_comma : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState005 ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState007 ->
          _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_009 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_LEFTPAR -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LEFTPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let l = _v in
      let _v = _menhir_action_166 l in
      _menhir_goto_type_vars _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_type_vars : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_file_parser) _menhir_state -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState043 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState001 ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_008 : type  ttv_stack. (ttv_stack, _menhir_box_file_parser) _menhir_cell1_type_var -> _ -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_type_var (_menhir_stack, _menhir_s, alpha, _, _) = _menhir_stack in
      let l = _v in
      let _v = _menhir_action_113 alpha l in
      _menhir_goto_list1_type_var_sep_comma _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  let rec _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_file_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | TYPE ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | THEORY ->
          _menhir_run_057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | REWRITING ->
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | PRED ->
          _menhir_run_296 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | LOGIC ->
          _menhir_run_312 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | GOAL ->
          _menhir_run_325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | FUNC ->
          _menhir_run_329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | EOF ->
          let _v = _menhir_action_031 () in
          MenhirBox_file_parser _v
      | AXIOM ->
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | _ ->
          _eRR ()
  
  let rec _menhir_run_348 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_lexpr_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState348 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState348 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState348
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState348 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState348 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState348 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState348 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
      | _ ->
          _eRR ()
  
  let rec _menhir_run_352 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_trigger_parser =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
      | TRUE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
      | STRING _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState352
      | NUM _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_135 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState352 _tok
      | NOT ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | MINUS ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | MATCH ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | LET ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | LEFTSQ ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | LEFTPAR ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | LEFTBR ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | INTEGER _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_i_, _startpos_i_, i) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_134 _endpos_i_ _startpos_i_ i in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_i_ _startpos_i_ _v MenhirState352 _tok
      | IF ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | ID _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_035 id in
          _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v MenhirState352 _tok
      | FORALL ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | FALSE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_137 _endpos__1_ _startpos__1_ in
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
      | EXISTS ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | DISTINCT ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | CUT ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | CHECK ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | _ ->
          _eRR ()
  
end

let trigger_parser =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_trigger_parser v = _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let lexpr_parser =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_lexpr_parser v = _menhir_run_348 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let file_parser =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_file_parser v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
